-- Esborrat de disparadors i seqncies
-- -------------------------------------

/*
DROP TRIGGER t_INS_regions;
DROP TRIGGER t_INS_localitats;
DROP TRIGGER t_INS_estatsVotacio;
DROP TRIGGER t_INS_opcions;
DROP TRIGGER t_INS_votacions;
DROP TRIGGER t_INS_estadistiquesVotacions;
DROP TRIGGER t_INS_opcionsVotacio;
DROP TRIGGER t_INS_historicVotacions;
DROP TRIGGER t_INS_logProcediments;

*/

/*
DROP SEQUENCE s_regions;
DROP SEQUENCE s_localitats;
DROP SEQUENCE s_estatsVotacio;
DROP SEQUENCE s_opcions;
DROP SEQUENCE s_votacions;
DROP SEQUENCE s_estadistiquesVotacions;
DROP SEQUENCE s_opcionsVotacio;
DROP SEQUENCE s_historicVotacions;
DROP SEQUENCE s_logProcediments;



-- Esborrat de taules
-- --------------------------------------------------------------


DROP TABLE logProcediments 		CASCADE CONSTRAINTS PURGE;
DROP TABLE historicVotacions		CASCADE CONSTRAINTS PURGE;
DROP TABLE maxParticipacionsCiutada	CASCADE CONSTRAINTS PURGE;
DROP TABLE estadistiquesAnuals		CASCADE CONSTRAINTS PURGE;
DROP TABLE censosLocalsAnys		CASCADE CONSTRAINTS PURGE;
DROP TABLE censosRegionalsAnys		CASCADE CONSTRAINTS PURGE;
DROP TABLE censosEstatalsAnys		CASCADE CONSTRAINTS PURGE;
DROP TABLE censGlobalAnys		CASCADE CONSTRAINTS PURGE;
DROP TABLE participacionsPaisosVotacions CASCADE CONSTRAINTS PURGE;
DROP TABLE votacionsPaisos		CASCADE CONSTRAINTS PURGE;
DROP TABLE votsEmesos			CASCADE CONSTRAINTS PURGE;
DROP TABLE ciutadansVotacions		CASCADE CONSTRAINTS PURGE;
DROP TABLE ciutadans			CASCADE CONSTRAINTS PURGE;
DROP TABLE censosAssociats		CASCADE CONSTRAINTS PURGE;
DROP TABLE opcionsVotacio		CASCADE CONSTRAINTS PURGE;
DROP TABLE estadistiquesVotacions	CASCADE CONSTRAINTS PURGE;
DROP TABLE votacions			CASCADE CONSTRAINTS PURGE;
DROP TABLE opcions			CASCADE CONSTRAINTS PURGE;
DROP TABLE estatsVotacio		CASCADE CONSTRAINTS PURGE;
DROP TABLE censosLocals			CASCADE CONSTRAINTS PURGE;
DROP TABLE censosRegionals 		CASCADE CONSTRAINTS PURGE;
DROP TABLE censosEstatals 		CASCADE CONSTRAINTS PURGE;
DROP TABLE censGlobal 			CASCADE CONSTRAINTS PURGE;
DROP TABLE localitats 			CASCADE CONSTRAINTS PURGE;
DROP TABLE regions 			CASCADE CONSTRAINTS PURGE;
DROP TABLE paisos 			CASCADE CONSTRAINTS PURGE;
DROP TABLE codisISO 			CASCADE CONSTRAINTS PURGE;
DROP TABLE anys 			CASCADE CONSTRAINTS PURGE;


*/



-- Creaci de taules
-- --------------------------------------------------------------

CREATE TABLE anys (
 lany	NUMBER(4)	CONSTRAINT PK_anys PRIMARY KEY,
 			CONSTRAINT CH_anys CHECK(lany >= 2000)
);



CREATE TABLE codisISO (
 codi_pais	CHAR(2)			CONSTRAINT PK_codisISO PRIMARY KEY,
 nom_pais	VARCHAR2(30 CHAR)	CONSTRAINT NN_codisISO_nom_pais NOT NULL
					CONSTRAINT UN_codisISO UNIQUE
);




CREATE TABLE paisos (
 nom_pais	VARCHAR2(30 CHAR)	CONSTRAINT PK_paisos PRIMARY KEY,
 codi_pais	CHAR(2)			CONSTRAINT NN_paisos_codi_pais NOT NULL
					CONSTRAINT UN_paisos UNIQUE
					CONSTRAINT FK_paisos_codi_pais REFERENCES codisISO(codi_pais) ON DELETE CASCADE
);



CREATE TABLE regions ( 
 id		NUMBER			CONSTRAINT PK_regions PRIMARY KEY,
 id_pais	VARCHAR2(30 CHAR)	CONSTRAINT NN_regions_id_pais NOT NULL
					CONSTRAINT FK_regions_id_pais REFERENCES paisos(nom_pais) ON DELETE CASCADE,
 nom_regio	VARCHAR2(40 CHAR)	CONSTRAINT NN_regions_nom_regio NOT NULL,
 CONSTRAINT UN_regions UNIQUE(id_pais, nom_regio) 
);



CREATE TABLE localitats ( 
 id		NUMBER			CONSTRAINT PK_localitats PRIMARY KEY,
 id_regio	NUMBER			CONSTRAINT NN_localitats_id_regio NOT NULL
					CONSTRAINT FK_localitats_id_regio REFERENCES regions(id) ON DELETE CASCADE,
 nom_localitat	VARCHAR2(40 CHAR)	CONSTRAINT NN_localitats_nom_localitat NOT NULL,
 CONSTRAINT UN_localitats UNIQUE(id_regio, nom_localitat)
);



CREATE TABLE estatsVotacio (
 id		NUMBER						CONSTRAINT PK_estatsVotacio PRIMARY KEY,
 nom_estat	VARCHAR2(20 CHAR)	DEFAULT 'edicio'	CONSTRAINT NN_estatsVotacio_nom_estat NOT NULL
								CONSTRAINT UN_estatsVotacio_nom_estat UNIQUE,
 CONSTRAINT CH_estatsVotacio_nom_estat CHECK(nom_estat IN('edicio', 'pendent obertura', 'oberta', 'finalitzada'))
);



CREATE TABLE censGlobal ( 
 nom_cens	VARCHAR2(30 CHAR)	CONSTRAINT PK_censGlobal PRIMARY KEY 
);



CREATE TABLE censosEstatals ( 
 nom_cens	VARCHAR2(30 CHAR)	CONSTRAINT PK_censosEstatals PRIMARY KEY,
 id_cens_global	VARCHAR2(30 CHAR)	CONSTRAINT NN_censosEstatals_idCensGlob NOT NULL
					CONSTRAINT FK_censosEstatals_idCensGlob REFERENCES censGlobal(nom_cens) ON DELETE CASCADE,
 codi_pais	CHAR(2)			CONSTRAINT NN_censosEstatals_codi_pais NOT NULL
					CONSTRAINT FK_censosEstatals_codi_pais REFERENCES paisos(codi_pais) ON DELETE CASCADE
);



CREATE TABLE censosRegionals ( 
 nom_cens		VARCHAR2(40 CHAR)	CONSTRAINT PK_censosRegionals PRIMARY KEY,
 id_cens_estatal	VARCHAR2(30 CHAR)	CONSTRAINT NN_censosRegionals_idCensEst NOT NULL
						CONSTRAINT FK_censosRegionals_idCensEst REFERENCES censosEstatals(nom_cens) ON DELETE CASCADE,
 id_regio		NUMBER			CONSTRAINT NN_censosRegionals_idRegio NOT NULL
						CONSTRAINT FK_censosRegionals_idRegio REFERENCES Regions(id) ON DELETE CASCADE,
 nom_regio		VARCHAR2(40 CHAR)	CONSTRAINT NN_censosRegionals_nom_regio NOT NULL
);




CREATE TABLE censosLocals (
 nom_cens		VARCHAR2(40 CHAR)		CONSTRAINT PK_censosLocals PRIMARY KEY,
 id_cens_regional	VARCHAR2(40 CHAR)		CONSTRAINT NN_censosLocals_idCensReg NOT NULL
							CONSTRAINT FK_censosLocals_idCensReg REFERENCES censosRegionals(nom_cens) ON DELETE CASCADE,
 id_localitat		NUMBER				CONSTRAINT NN_censosLocals_id_localitat NOT NULL
							CONSTRAINT FK_censosLocals_id_localitat REFERENCES Localitats(id) ON DELETE CASCADE,
 nom_localitat		VARCHAR2(40 CHAR)		CONSTRAINT NN_censosLocals_nom_localitat NOT NULL,
 ciutadans_censats	NUMBER		DEFAULT 0	CONSTRAINT NN_censosLocals_ciutadCensats NOT NULL
							CONSTRAINT CH_censosLocals_ciutadCensats CHECK(ciutadans_censats >= 0)
);





CREATE TABLE opcions ( 
 id		NUMBER				CONSTRAINT PK_opcions PRIMARY KEY,
 nom_opcio	VARCHAR2(15 CHAR)		CONSTRAINT NN_opcions_nom_opcio NOT NULL,
 descripcio	VARCHAR2(100 CHAR),
 codi_pais	CHAR(2)				CONSTRAINT NN_opcions_codi_pais NOT NULL
						CONSTRAINT FK_opcions_codi_pais REFERENCES codisISO(codi_pais) ON DELETE CASCADE,
 baixa_logica	NUMBER(1)	DEFAULT 0	CONSTRAINT NN_opcions_baixa_logica NOT NULL
						CONSTRAINT CH_opcions_baixa_logica CHECK(baixa_logica IN (0,1)),
 CONSTRAINT UN_opcions UNIQUE(nom_opcio, codi_pais)
);




-- Nota: La restricci de data_inici > SYSDATE no l'he he pogut fer amb CHECK.Caldr controlar-les amb el procediment d'alta de votacions.
-- Potser tamb caldria controlar en el procediment que data_fi > data_inci (aix podrem mostrar missatges personalitzats)
CREATE TABLE votacions (
 id		NUMBER				CONSTRAINT PK_votacions PRIMARY KEY,
 id_cens_global	VARCHAR2(30 CHAR)		CONSTRAINT NN_votacions_id_cens_global NOT NULL
						CONSTRAINT FK_votacions_id_cens_global REFERENCES censGlobal(nom_cens) ON DELETE CASCADE,
 id_estat	NUMBER				CONSTRAINT NN_votacions_id_estat NOT NULL
						CONSTRAINT FK_votacions_id_estat REFERENCES estatsVotacio(id) ON DELETE CASCADE,
 titol		VARCHAR2(100 CHAR)		CONSTRAINT NN_votacions_titol NOT NULL
						CONSTRAINT UN_votacions UNIQUE,
 data_inici	DATE				CONSTRAINT NN_votacions_data_inici NOT NULL,
 data_fi	DATE				CONSTRAINT NN_votacions_data_fi NOT NULL,
 any_votacio	NUMBER(4)			CONSTRAINT NN_votacions_any_votacio NOT NULL
						CONSTRAINT FK_votacions_any_votacio REFERENCES ANYS(lany) ON DELETE CASCADE,
 adreca_web	VARCHAR2(200 CHAR),
 president_mesa	VARCHAR2(100 CHAR)		CONSTRAINT NN_votacions_president_mesa NOT NULL,
 num_electors	NUMBER		DEFAULT 0	CONSTRAINT NN_votacions_num_electors NOT NULL
						CONSTRAINT CH_cvotacions_num_electors CHECK(num_electors >= 0),
 CONSTRAINT CH_votacions_data_fi CHECK(data_fi >= data_inici)
);





CREATE TABLE estadistiquesVotacions (
 id				NUMBER				CONSTRAINT PK_estadVotacions PRIMARY KEY,
 id_votacio			NUMBER				CONSTRAINT NN_estadVotacions_id_votacio NOT NULL
								CONSTRAINT FK_estadVotacions_id_votacio REFERENCES votacions(id) ON DELETE CASCADE,
 titol_votacio			VARCHAR2(200)			CONSTRAINT NN_estadVotacions_titol_vota NOT NULL,
 any_votacio			NUMBER(4)			CONSTRAINT NN_estadVotacions_any_votacio NOT NULL,
 finalitzada			NUMBER(1)	DEFAULT 0	CONSTRAINT NN_estadVotacions_finalitzada NOT NULL
								CONSTRAINT CH_estadVotacions_finalitzada CHECK(finalitzada IN (0,1)),
 num_electors			NUMBER		DEFAULT 0	CONSTRAINT NN_estadVotacions_num_electors NOT NULL
								CONSTRAINT CH_estadVotacions_num_electors CHECK(num_electors >= 0),
 num_vots			NUMBER		DEFAULT 0	CONSTRAINT NN_estadVotacions_num_vots NOT NULL
								CONSTRAINT CH_estadVotacions_num_vots CHECK(num_vots >= 0),
 participacio			NUMBER(5,2)	DEFAULT 0	CONSTRAINT NN_estadVotacions_participacio NOT NULL
								CONSTRAINT CH_estadVotacions_participacio CHECK(participacio >= 0),
 id_opcio_mes_vots		VARCHAR2(20 CHAR),
 nom_opcio_mes_vots		VARCHAR2(150 CHAR),
 vots_opcio_mes_vots		NUMBER		DEFAULT 0	CONSTRAINT NN_estadVotacions_votsOpMesVot NOT NULL
								CONSTRAINT CH_estadVotacions_votsOpMesVot CHECK(vots_opcio_mes_vots >= 0),
 percentatge_opcio_mes_vots	NUMBER(5,2)	DEFAULT 0	CONSTRAINT NN_estadVotacions_percOpMesVot NOT NULL
								CONSTRAINT CH_estadVotacions_percOpMesVot CHECK(percentatge_opcio_mes_vots >= 0),
 id_opcio_menys_vots		VARCHAR2(20 CHAR),
 nom_opcio_menys_vots		VARCHAR2(150 CHAR),
 vots_opcio_menys_vots		NUMBER		DEFAULT 0	CONSTRAINT NN_estadVotacio_votsOpMenysVot NOT NULL
								CONSTRAINT CH_estadVotacio_votsOpMenysVot CHECK(vots_opcio_menys_vots >= 0),
 percentatge_opcio_menys_vots	NUMBER(5,2)	DEFAULT 0	CONSTRAINT NN_estadVotacio_percOpMenysVot NOT NULL
								CONSTRAINT CH_estadVotacio_percOpMenysVot CHECK(percentatge_opcio_menys_vots >= 0),
 dif_perc_opc_mes_i_menys_vots	NUMBER(5,2)	DEFAULT 0	CONSTRAINT NN_estadVotacio_difPercOpcions NOT NULL
								CONSTRAINT CH_estadVotacio_difPercOpcions CHECK(dif_perc_opc_mes_i_menys_vots >= 0)
);




CREATE TABLE opcionsVotacio (
 id		NUMBER				CONSTRAINT PK_opcionsVotacio PRIMARY KEY,
 id_votacio	NUMBER				CONSTRAINT NN_opcionsVotacio_id_votacio NOT NULL
						CONSTRAINT FK_opcionsVotacio_id_votacio REFERENCES votacions(id) ON DELETE CASCADE,
 id_opcio	NUMBER				CONSTRAINT NN_opcionsVotacio_id_opcio NOT NULL
						CONSTRAINT FK_opcionsVotacio_id_opcio REFERENCES opcions(id) ON DELETE CASCADE,
 num_vots	NUMBER		DEFAULT 0	CONSTRAINT NN_opcionsVotacio_num_vots NOT NULL
						CONSTRAINT CH_opcionsVotacio_num_vots CHECK(num_vots >= 0),
 CONSTRAINT UN_opcionsVotacio UNIQUE(id_votacio, id_opcio)
);




-- Nota: la data de naixement s'haur de controlar en el procediment d'insercions
CREATE TABLE ciutadans (
 num_aleatori		NUMBER(10)			CONSTRAINT PK_ciutadans PRIMARY KEY,
 id_cens_local		VARCHAR2(40 CHAR)		CONSTRAINT NN_ciutadans_id_cens_local NOT NULL
							CONSTRAINT FK_ciutadans_id_cens_local REFERENCES censosLocals(nom_cens) ON DELETE CASCADE,
 id_localitat		NUMBER				CONSTRAINT NN_ciutadans_id_localitat NOT NULL
							CONSTRAINT FK_ciutadans_id_localitat REFERENCES localitats(id) ON DELETE CASCADE,
 data_naixement		DATE				CONSTRAINT NN_ciutadans_data_naixement NOT NULL,
 nom_pais		VARCHAR2(30 CHAR)		CONSTRAINT NN_ciutadans_nom_pais NOT NULL,
 baixa_logica		NUMBER(1)	DEFAULT 0	CONSTRAINT NN_ciutadans_baixa_logica NOT NULL
							CONSTRAINT CH_ciutadans_baixa_logica CHECK(baixa_logica IN (0,1)),
 num_participacions	NUMBER		DEFAULT 0	CONSTRAINT NN_ciutadans_num_particip NOT NULL
							CONSTRAINT CH_ciutadans_num_particip CHECK(num_participacions >= 0)
);



CREATE TABLE censosAssociats (
 id_votacio		NUMBER				CONSTRAINT FK_censosAssociats_id_votacio REFERENCES votacions(id) ON DELETE CASCADE,
 id_cens_local		VARCHAR2(40 CHAR)		CONSTRAINT FK_censosAssociats_idCensLocal REFERENCES censosLocals(nom_cens) ON DELETE CASCADE,
 cens_estatal		VARCHAR2(30 CHAR)		CONSTRAINT NN_censosAssociats_idCensEstat NOT NULL,
 cens_regional		VARCHAR2(40 CHAR)		CONSTRAINT NN_censosAssociats_idCensRegio NOT NULL,
 nom_localitat		VARCHAR2(40 CHAR)		CONSTRAINT NN_censosAssociats_nomLocalita NOT NULL,
 nom_pais		VARCHAR2(40 CHAR)		CONSTRAINT NN_censosAssociats_nom_pais NOT NULL,
 any_votacio		NUMBER(4)			CONSTRAINT NN_censosAssociats_any_votacio NOT NULL,
 ciutadans_censats	NUMBER		DEFAULT 0	CONSTRAINT NN_censosAssociats_ciutCensats NOT NULL
							CONSTRAINT CH_censosAssociats_ciutCensats CHECK(ciutadans_censats >= 0),
 finalitzada		NUMBER(1)	DEFAULT 0	CONSTRAINT NN_censosAssociats_finalitzada NOT NULL
							CONSTRAINT CH_censosAssociats_finalitzada CHECK(finalitzada IN (0,1)),
 num_vots		NUMBER		DEFAULT 0	CONSTRAINT NN_censosAssociats_num_vots NOT NULL
							CONSTRAINT CH_censosAssociats_num_vots CHECK(num_vots >= 0),
 CONSTRAINT PK_censosAssociats PRIMARY KEY(id_votacio, id_cens_local)
);




CREATE TABLE ciutadansVotacions (
 id_ciutada	NUMBER				CONSTRAINT FK_ciutadVotacions_id_ciutada REFERENCES ciutadans(num_aleatori) ON DELETE CASCADE,
 id_votacio	NUMBER				CONSTRAINT FK_ciutadVotacions_id_votacio REFERENCES votacions(id) ON DELETE CASCADE,
 any_votacio	NUMBER(4)			CONSTRAINT NN_ciutadVotacions_any_votacio NOT NULL,
 ha_participat	NUMBER(1)	DEFAULT 0	CONSTRAINT NN_ciutadVotacions_haParticip NOT NULL
						CONSTRAINT CH_ciutadVotacions_haParticip CHECK(ha_participat IN (0,1)),
 CONSTRAINT PK_ciutadansVotacions PRIMARY KEY(id_ciutada, id_votacio)
);



CREATE TABLE votsEmesos (
 id_ciutada	NUMBER		CONSTRAINT FK_votsEmesos_id_ciutada REFERENCES ciutadans(num_aleatori) ON DELETE CASCADE,
 id_votacio	NUMBER		CONSTRAINT FK_votsEmesos_id_votacio REFERENCES votacions(id) ON DELETE CASCADE,
 id_opcio	NUMBER		CONSTRAINT NN_votsEmesos_id_opcio NOT NULL
				CONSTRAINT FK_votsEmesos_id_opcio REFERENCES opcionsVotacio(id) ON DELETE CASCADE,
 data_hora	TIMESTAMP	CONSTRAINT NN_votsEmesos_data_hora NOT NULL,
 CONSTRAINT PK_votsEmesos PRIMARY KEY(id_ciutada, id_votacio)
);



CREATE TABLE votacionsPaisos (
 id_pais	VARCHAR2(30 CHAR)	CONSTRAINT FK_votacionsPaisos_id_pais REFERENCES paisos(nom_pais) ON DELETE CASCADE,
 id_votacio	NUMBER			CONSTRAINT FK_votacionsPaisos_id_votacio REFERENCES votacions(id) ON DELETE CASCADE,
 CONSTRAINT PK_votacionsPaisos PRIMARY KEY(id_pais, id_votacio)
);



CREATE TABLE participacionsPaisosVotacions (
 id_pais		VARCHAR2(30 CHAR)		CONSTRAINT FK_partPaisosvotacions_id_pais REFERENCES paisos(nom_pais) ON DELETE CASCADE,
 lany			NUMBER(4)			CONSTRAINT FK_partPaisosvotacions_any REFERENCES anys(lany) ON DELETE CASCADE,
 num_participacions	NUMBER		DEFAULT 0	CONSTRAINT NN_partPaisosvotacions_numPart NOT NULL
							CONSTRAINT CH_partPaisosvotacions_numPart CHECK(num_participacions >= 0),
 CONSTRAINT PK_partPaisosvotacions PRIMARY KEY(id_pais, lany)
);



CREATE TABLE censGlobalAnys (
 lany			NUMBER(4)			CONSTRAINT PK_censGlobAnys PRIMARY KEY
							CONSTRAINT FK_censGlobAnys_any REFERENCES anys(lany) ON DELETE CASCADE,
 id_cens_global		VARCHAR2(30)			CONSTRAINT NN_censGlobAnys_id_cens_global NOT NULL
							CONSTRAINT FK_censGlobAnys_id_cens_global REFERENCES censGlobal(nom_cens) ON DELETE CASCADE,
 total_electors		NUMBER		DEFAULT 0	CONSTRAINT NN_censGlobAnys_total_electors NOT NULL
							CONSTRAINT CH_censGlobAnys_total_electors CHECK(total_electors >= 0),
 total_vots		NUMBER		DEFAULT 0	CONSTRAINT NN_censGlobAnys_total_vots NOT NULL
							CONSTRAINT CH_censGlobAnys_total_vots CHECK(total_vots >= 0),
 participacio		NUMBER(5,2)	DEFAULT 0	CONSTRAINT NN_censGlobAnys_participacio NOT NULL
							CONSTRAINT CH_censGlobAnys_participacio CHECK(participacio >= 0),
 num_votacions		NUMBER		DEFAULT 0	CONSTRAINT NN_censGlobAnys_num_votacions NOT NULL
							CONSTRAINT CH_censGlobAnys_num_votacions CHECK(num_votacions >= 0)
);



CREATE TABLE censosEstatalsAnys (
 lany			NUMBER(4)			CONSTRAINT FK_censEstaAnys_any REFERENCES anys(lany) ON DELETE CASCADE,
 id_cens_estatal	VARCHAR2(30)			CONSTRAINT FK_censEstaAnys_id_cens_global REFERENCES censosEstatals(nom_cens) ON DELETE CASCADE,
 total_electors		NUMBER		DEFAULT 0	CONSTRAINT NN_censEstaAnys_total_electors NOT NULL
							CONSTRAINT CH_censEstaAnys_total_electors CHECK(total_electors >= 0),
 total_vots		NUMBER		DEFAULT 0	CONSTRAINT NN_censEstaAnys_total_vots NOT NULL
							CONSTRAINT CH_censEstaAnys_total_vots CHECK(total_vots >= 0),
 participacio		NUMBER(5,2)	DEFAULT 0	CONSTRAINT NN_censEstaAnys_participacio NOT NULL
							CONSTRAINT CH_censEstaAnys_participacio CHECK(participacio >= 0),
 num_votacions		NUMBER		DEFAULT 0	CONSTRAINT NN_censEstaAnys_num_votacions NOT NULL
							CONSTRAINT CH_censEstaAnys_num_votacions CHECK(num_votacions >= 0),
 CONSTRAINT PK_censosEstatalsAnys PRIMARY KEY(lany, id_cens_estatal)
);



CREATE TABLE censosRegionalsAnys (
 lany			NUMBER(4)			CONSTRAINT FK_censosRegiAnys_any REFERENCES anys(lany) ON DELETE CASCADE,
 id_cens_regional	VARCHAR2(40)			CONSTRAINT FK_censosRegiAnys_id_cens_glo REFERENCES censosRegionals(nom_cens) ON DELETE CASCADE,
 total_electors		NUMBER		DEFAULT 0	CONSTRAINT NN_censosRegiAnys_total_elect NOT NULL
							CONSTRAINT CH_censosRegiAnys_total_elect CHECK(total_electors >= 0),
 total_vots		NUMBER		DEFAULT 0	CONSTRAINT NN_censosRegiAnys_total_vots NOT NULL
							CONSTRAINT CH_censosRegiAnys_total_vots CHECK(total_vots >= 0),
 participacio		NUMBER(5,2)	DEFAULT 0	CONSTRAINT NN_censosRegiAnys_participacio NOT NULL
							CONSTRAINT CH_censosRegiAnys_participacio CHECK(participacio >= 0),
 num_votacions		NUMBER		DEFAULT 0	CONSTRAINT NN_censosRegiAnys_num_votacio NOT NULL
							CONSTRAINT CH_censosRegiAnys_num_votacio CHECK(num_votacions >= 0),
 CONSTRAINT PK_censosRegionalsAnys PRIMARY KEY(lany, id_cens_regional)
);





CREATE TABLE censosLocalsAnys (
 lany			NUMBER(4)			CONSTRAINT FK_censosLocalAnys_any REFERENCES anys(lany) ON DELETE CASCADE,
 id_cens_local		VARCHAR2(40)			CONSTRAINT FK_censosLocalAnys_id_cens_reg REFERENCES censosLocals(nom_cens) ON DELETE CASCADE,
 total_electors		NUMBER		DEFAULT 0	CONSTRAINT NN_censosLocalAnys_total_elect NOT NULL
							CONSTRAINT CH_censosLocalAnys_total_elect CHECK(total_electors >= 0),
 total_vots		NUMBER		DEFAULT 0	CONSTRAINT NN_censosLocalAnys_total_vots NOT NULL
							CONSTRAINT CH_censosLocalAnys_total_vots CHECK(total_vots >= 0),
 participacio		NUMBER(5,2)	DEFAULT 0	CONSTRAINT NN_censosLocalAnys_participaci NOT NULL
							CONSTRAINT CH_censosLocalAnys_participaci CHECK(participacio >= 0),
 num_votacions		NUMBER		DEFAULT 0	CONSTRAINT NN_censosLocalAnys_num_votacio NOT NULL
							CONSTRAINT CH_censosLocalAnys_num_votacio CHECK(num_votacions >= 0),
 CONSTRAINT PK_censosLocalsAnys PRIMARY KEY(lany, id_cens_local)
);



-- NOTA: votacions_mes_participacio i localitats_mes_vots tenen una capacitat considerable per si es dna la casualitat de que en un mateix any
-- hi hagi ms d'una votaci amb un mxim de participaci i/o ms d'una localitat amb un nmero mxim de vots.
CREATE TABLE estadistiquesAnuals (
 lany				NUMBER(4)				CONSTRAINT PK_estadistAnuals PRIMARY KEY
									CONSTRAINT FK_estadistAnuals_any REFERENCES anys(lany) ON DELETE CASCADE,
 votacions_mes_participacio	VARCHAR2(300 CHAR)	DEFAULT NULL,
 participacio			NUMBER(5,2)		DEFAULT 0	CONSTRAINT NN_estadistAnuals_votacio_mes NOT NULL
									CONSTRAINT CH_estadistAnuals_votacio_mes CHECK(participacio >= 0),
 localitats_mes_vots		VARCHAR2(480 CHAR)	DEFAULT NULL,
 num_vots			NUMBER			DEFAULT 0	CONSTRAINT NN_estadistAnuals_num_vots NOT NULL
									CONSTRAINT CH_estadistAnuals_num_vots CHECK(num_vots >= 0),
 ciutadans_no_han_votat_mai	NUMBER(5,2)		DEFAULT 0	CONSTRAINT NN_estadistAnuals_ciutMaiVotat NOT NULL
									CONSTRAINT CH_estadistAnuals_ciutMaiVotat CHECK(ciutadans_no_han_votat_mai >= 0)
);





CREATE TABLE maxParticipacionsCiutada (
 id_aleatori_ciutada	NUMBER				CONSTRAINT PK_maxParticipCiutada PRIMARY KEY
							CONSTRAINT FK_maxParticipCiutada_id_aleat REFERENCES ciutadans(num_aleatori) ON DELETE CASCADE,
 pais			VARCHAR2(30 CHAR)		CONSTRAINT NN_maxParticipCiutada_pais NOT NULL,
 num_participacions	NUMBER		DEFAULT 0	CONSTRAINT NN_maxParticipCiutada_num_part NOT NULL
							CONSTRAINT CH_maxParticipCiutada_num_part CHECK(num_participacions >= 0)
);



-- NOTA: Tot i que s poc probable, hi pot haver ms d'una votaci amb els mateixos valors mxims/mnims. Es reserven 300 CHAR per si cal guardar-ne ms d'una.
CREATE TABLE historicVotacions (
 id				NUMBER					CONSTRAINT PK_historicVot PRIMARY KEY,
 votacio_mes_participacio	VARCHAR2(300 CHAR)			CONSTRAINT NN_historicVot_vot_mes_part NOT NULL,
 participacio			NUMBER(5,2)		DEFAULT 0	CONSTRAINT NN_historicVot_participacio NOT NULL
									CONSTRAINT CH_historicVot_participacio CHECK(participacio >= 0),
 votacio_max_diferencia_opcions	VARCHAR2(300 CHAR)			CONSTRAINT NN_historicVot_vot_max_dif NOT NULL,
 diferencia_max			NUMBER(5,2)		DEFAULT 0	CONSTRAINT NN_historicVot_dif_max_opc NOT NULL
									CONSTRAINT CH_historicVot_dif_max CHECK(diferencia_max >= 0),
 votacio_min_diferencia_opcions	VARCHAR2(300 CHAR)			CONSTRAINT NN_historicVot_vot_min_dif NOT NULL,
 diferencia_min			NUMBER(5,2)		DEFAULT 0	CONSTRAINT NN_historicVot_dif_min NOT NULL
									CONSTRAINT CH_historicVot_dif_min CHECK(diferencia_min >= 0)
);




-- Nota: les restriccions CHECK dels camps 'correcte' i 'confirmar' tamb es controlaran en el procediment p_registrarLog
CREATE TABLE logProcediments (
 id			NUMBER					CONSTRAINT PK_logProcediments PRIMARY KEY,
 data			TIMESTAMP(0)				CONSTRAINT NN_logProcediments_data NOT NULL,
 nom_procediment 	VARCHAR2(30 CHAR) 			CONSTRAINT NN_logProcediments_nom NOT NULL,
 parametres_entrada	VARCHAR2(650 CHAR),
 sortida		VARCHAR2(200 CHAR)			CONSTRAINT NN_logProcediments_sortida NOT NULL,
 correcte		NUMBER(1)		DEFAULT 1	CONSTRAINT NN_logProcediments_correcte NOT NULL
								CONSTRAINT CH_logProcediments_correcte CHECK(correcte IN (0,1)),
 confirmar		NUMBER(1)		DEFAULT 1	CONSTRAINT NN_logProcediments_confirmar NOT NULL
								CONSTRAINT CH_logProcediments_confirmar CHECK(confirmar IN (0,1))
);
















-- creaci de seqncies i disparadors
-- -----------------------------------


CREATE SEQUENCE s_regions			INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE s_localitats			INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE s_estatsVotacio			INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE s_opcions			INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE s_votacions			INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE s_estadistiquesVotacions	INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE s_opcionsVotacio		INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE s_historicVotacions		INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE s_logProcediments 		INCREMENT BY 1 START WITH 1;



CREATE OR REPLACE TRIGGER t_INS_regions
 BEFORE INSERT ON regions
 FOR EACH ROW
 BEGIN
  SELECT s_regions.NEXTVAL INTO :NEW.id FROM DUAL;
 END t_INS_regions;
/


CREATE OR REPLACE TRIGGER t_INS_localitats
 BEFORE INSERT ON localitats
 FOR EACH ROW
 BEGIN
  SELECT s_localitats.NEXTVAL INTO :NEW.id FROM DUAL;
 END t_INS_localitats;
/


CREATE OR REPLACE TRIGGER t_INS_estatsVotacio
 BEFORE INSERT ON estatsVotacio
 FOR EACH ROW
 BEGIN
  SELECT s_estatsVotacio.NEXTVAL INTO :NEW.id FROM DUAL;
 END t_INS_estatsVotacio;
/


CREATE OR REPLACE TRIGGER t_INS_opcions
 BEFORE INSERT ON opcions
 FOR EACH ROW
 BEGIN
  SELECT s_opcions.NEXTVAL INTO :NEW.id FROM DUAL;
 END t_INS_opcions;
/


CREATE OR REPLACE TRIGGER t_INS_votacions
 BEFORE INSERT ON votacions
 FOR EACH ROW
 BEGIN
  SELECT s_votacions.NEXTVAL INTO :NEW.id FROM DUAL;
 END t_INS_votacions;
/


CREATE OR REPLACE TRIGGER t_INS_estadistiquesVotacions
 BEFORE INSERT ON estadistiquesVotacions
 FOR EACH ROW
 BEGIN
  SELECT s_estadistiquesVotacions.NEXTVAL INTO :NEW.id FROM DUAL;
 END t_INS_estadistiquesVotacions;
/


CREATE OR REPLACE TRIGGER t_INS_opcionsVotacio
 BEFORE INSERT ON opcionsVotacio
 FOR EACH ROW
 BEGIN
  SELECT s_opcionsVotacio.NEXTVAL INTO :NEW.id FROM DUAL;
 END t_INS_opcionsVotacio;
/


CREATE OR REPLACE TRIGGER t_INS_historicVotacions
 BEFORE INSERT ON historicVotacions
 FOR EACH ROW
 BEGIN
  SELECT s_historicVotacions.NEXTVAL INTO :NEW.id FROM DUAL;
 END t_INS_historicVotacions;
/




CREATE OR REPLACE TRIGGER t_INS_logProcediments
 BEFORE INSERT ON logProcediments
 FOR EACH ROW
 BEGIN
  SELECT s_logProcediments.NEXTVAL INTO :NEW.id FROM DUAL;
 END t_INS_logProcediments;
/







