SET SERVEROUTPUT ON;
SET LINESIZE 180;


DECLARE


  RSP 		VARCHAR2(200 CHAR);
  pais		VARCHAR2(30 CHAR);
  cod_pais	CHAR(2);
  id_vota	NUMBER := 0;
  id_opc	NUMBER := 0;
  num		NUMBER(3) := 0;

BEGIN





-- ************************************ votaci al municipi de Sevilla 02/01/2000 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Sevilla');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Sevilla de 2 de gener de 2000';


-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Andalusia_Sevilla', 'cens Espanya', 'cens ES_Andalusia', 'Sevilla', 'Espanya', 2000, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Andalusia_Sevilla per votacio al municipi de Sevilla de 02/01/2010: '||RSP);



 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);


 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 2, 3, 5, 6, 9 o 0.
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 2 OR  
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Sevilla de 02/01/2000: '||RSP);





-- ************************************ votaci al municipi de Munich 03/01/2000 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Munich');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Munich de 3 de gener de 2000';


-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Baviera_Munich', 'cens Alemanya', 'cens DE_Baviera', 'Munich', 'Alemanya', 2000, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Baviera_Munich per votacio al municipi de Munich de 03/01/2000: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);


 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 1, 4, 7, 8, 9
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 1 OR  
		MOD(ciutada.id_ciutada, 10) = 4 OR 
		MOD(ciutada.id_ciutada, 10) = 7 OR 
		MOD(ciutada.id_ciutada, 10) = 8 OR 
		MOD(ciutada.id_ciutada, 10) = 9 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat:  'finalitzada')
-- ---------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Munich de 03/01/2000: '||RSP);










-- ************************************ votaci al municipi de Roma 02/01/2001 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Roma');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Roma de 2 de gener de 2001';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Laci_Roma', 'cens Italia', 'cens IT_Laci', 'Roma', 'Italia', 2001, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Laci_Roma per votacio al municipi de Roma de 02/01/2001: '||RSP);



 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 3, 6, 8 o 0.
	-- tpicament s'esperaria una participaci del 40%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 3 OR  
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 8 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat:  'finalitzada')
-- --------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Roma de 02/01/2001: '||RSP);










-- ************************************ votaci al municipi de Santander 03/01/2001 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Santander');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Santander de 3 de gener de 2001';


-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Cantabria_Santander', 'cens Espanya', 'cens ES_Cantabria', 'Santander', 'Espanya', 2001, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Cantabria_Santander per votacio al municipi de  de 03/01/2001: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 1, 2, 3, 4.
	-- tpicament s'esperaria una participaci del 40%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 1 OR  
		MOD(ciutada.id_ciutada, 10) = 2 OR 
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 4 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Santander de 03/01/2001: '||RSP);













-- ************************************ votaci al municipi de Berlin 02/01/2002 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Berlin');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Berlin de 2 de gener de 2002';


-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Berlin_Berlin', 'cens Alemanya', 'cens DE_Berlin', 'Berlin', 'Alemanya', 2002, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Berlin_Berlin per votacio al municipi de Berlin de 02/01/2002: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 5, 6, 7 o 8.
	-- tpicament s'esperaria una participaci del 40%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 5 OR  
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 7 OR 
		MOD(ciutada.id_ciutada, 10) = 8 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat:  'finalitzada')
-- --------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Berlin de 02/01/2002: '||RSP);










-- ************************************ votaci al municipi de  03/01/2002 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Toledo');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Toledo de 3 de gener de 2002';


-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Castella la Manxa_Toledo', 'cens Espanya', 'cens ES_Castella la Manxa', 'Toledo', 'Espanya', 2002, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Castella la Manxa_Toledo per votacio al municipi de  de 03/01/2002: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 1, 2, 3, 4, 5 o 6.
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 1 OR  
		MOD(ciutada.id_ciutada, 10) = 2 OR 
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 4 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Toledo de 03/01/2002: '||RSP);












-- ************************************ votaci al municipi de Florencia 02/01/2003 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Florencia');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Florencia de 2 de gener de 2003';


-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Toscana_Florencia', 'cens Italia', 'cens IT_Toscana', 'Florencia', 'Italia', 2003, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Toscana_Florencia per votacio al municipi de  de 02/01/2010: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 2, 3, 5, 6, 9 o 0.
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 2 OR  
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat:  'finalitzada')
-- --------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Florencia de 02/01/2003: '||RSP);










-- ************************************ votaci al municipi de Madrid 03/01/2003 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Madrid');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Madrid de 3 de gener de 2003';




-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat de Madrid_Madrid', 'cens Espanya', 'cens ES_Comunitat de Madrid', 'Madrid', 'Espanya', 2003, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat de Madrid per votacio al municipi de Madrid de 03/01/2003: '||RSP);



 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);




 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 1, 4, 7 o 8
	-- tpicament s'esperaria una participaci del 40%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 1 OR  
		MOD(ciutada.id_ciutada, 10) = 4 OR 
		MOD(ciutada.id_ciutada, 10) = 7 OR 
		MOD(ciutada.id_ciutada, 10) = 8 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Madrid de 03/01/2003: '||RSP);












-- ************************************ votaci al municipi de Barcelona 02/01/2004 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Barcelona');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Barcelona de 2 de gener de 2004';




-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Barcelona', 'cens Espanya', 'cens ES_Catalunya', 'Barcelona', 'Espanya', 2004, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Barcelona per votacio al municipi de Barcelona de 02/01/2004: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori senar.
	-- tpicament s'esperaria una participaci del 50%
	IF ( 	MOD(ciutada.id_ciutada, 2) = 1  ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat:  'finalitzada')
-- --------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Barcelona de 02/01/2004: '||RSP);










-- ************************************ votaci al municipi de Murcia 03/01/2004 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Murcia');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Murcia de 3 de gener de 2004';




-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat de Murcia_Murcia', 'cens Espanya', 'cens ES_Comunitat de Murcia', 'Murcia', 'Espanya', 2004, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat de Murcia_Murcia per votacio al municipi de Murcia de 03/01/2004: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 1, 2, 3, 5, 6, 7 o 9 .
	-- tpicament s'esperaria una participaci del 70%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 1 OR  
		MOD(ciutada.id_ciutada, 10) = 2 OR 
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 7 OR 
		MOD(ciutada.id_ciutada, 10) = 9 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Murcia de 03/01/2004: '||RSP);












-- ************************************ votaci al municipi de Dusseldorf 02/01/2005 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Dusseldorf');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Dusseldorf de 2 de gener de 2005';




-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Renania-Westfalia_Dusseldorf', 'cens Alemanya', 'cens DE_Renania del norte-Westfalia', 'Dusseldorf', 'Alemanya', 2005, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Renania-Westfalia_Dusseldorf per votacio al municipi de Dusseldorf de 02/01/2005: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);




 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori parell.
	-- tpicament s'esperaria una participaci del 50%
	IF ( MOD(ciutada.id_ciutada, 2) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat:  'finalitzada')
-- --------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Dusseldorf de 02/01/2005: '||RSP);










-- ************************************ votaci al municipi de Girona 03/01/2005 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Girona');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Girona de 3 de gener de 2005';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2005, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Girona per votacio al municipi de Girona de 03/01/2005: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);




 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 1, 2, 4, 5, 8, 9 o 0.
	-- tpicament s'esperaria una participaci del 70%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 1 OR  
		MOD(ciutada.id_ciutada, 10) = 2 OR 
		MOD(ciutada.id_ciutada, 10) = 3 OR
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 8 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Girona de 03/01/2005: '||RSP);












-- ************************************ votaci al municipi de Bolonya 02/01/2006 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Bolonya');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Bolonya de 2 de gener de 2006';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Emilia-Romanya_Bolonya', 'cens Italia', 'cens IT_Emilia-Romanya', 'Bolonya', 'Italia', 2006, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Emilia-Romanya per votacio al municipi de Bolonya de 02/01/2006: '||RSP);



 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 2, 3, 5, 6, 9 o 0.
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 2 OR  
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat:  'finalitzada')
-- --------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Bolonya de 02/01/2006: '||RSP);










-- ************************************ votaci al municipi de Murcia 03/01/2006 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Murcia');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Murcia de 3 de gener de 2006';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat de Murcia_Murcia', 'cens Espanya', 'cens ES_Comunitat de Murcia', 'Murcia', 'Espanya', 2006, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat de Murcia_Murcia per votacio al municipi de Murcia de 03/01/2010: '||RSP);



 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);




 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 1, 3, 5, 6, 8 o 0.
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 1 OR  
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 8 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Murcia de 03/01/2006: '||RSP);






-- ************************************ votaci al municipi de Hannover 02/01/2007 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Hannover');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Hannover de 2 de gener de 2007';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Baja Sajonia_Hannover', 'cens Alemanya', 'cens DE_Baja Sajonia', 'Hannover', 'Alemanya', 2007, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Baja Sajonia_Hannover per votacio al municipi de Hannover de 02/01/2007: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);




 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 2, 3, 5, 6, 9 o 0.
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 2 OR  
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat:  'finalitzada')
-- --------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Hannover de 02/01/2007: '||RSP);










-- ************************************ votaci al municipi de Florencia 03/01/2007 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Florencia');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Florencia de 3 de gener de 2007';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Toscana_Florencia', 'cens Italia', 'cens IT_Toscana', 'Florencia', 'Italia', 2007, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Toscana_Florencia per votacio al municipi de Florencia de 03/01/2007: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);




 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 5, 6, 8, 9 o 0.
	-- tpicament s'esperaria una participaci del 50%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 8 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Florencia de 03/01/2007: '||RSP);












-- ************************************ votaci al municipi de Barcelona 02/01/2008 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Barcelona');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Barcelona de 2 de gener de 2008';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Barcelona', 'cens Espanya', 'cens ES_Catalunya', 'Barcelona', 'Espanya', 2008, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Barcelona per votacio al municipi de Barcelona de 02/01/2008: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 2, 4, 5, 6, 9 o 0.
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 2 OR  
		MOD(ciutada.id_ciutada, 10) = 4 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat:  'finalitzada')
-- --------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Barcelona de 02/01/2008: '||RSP);










-- ************************************ votaci al municipi de Madrid 03/01/2008 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Madrid');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Madrid de 3 de gener de 2008';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat de Madrid_Madrid', 'cens Espanya', 'cens ES_Comunitat de Madrid', 'Madrid', 'Espanya', 2008, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat de Madrid_Madrid per votacio al municipi de Madrid de 03/01/2008: '||RSP);



 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 3, 6, 7, 9 o 0.
	-- tpicament s'esperaria una participaci del 50%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 7 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Madrid de 03/01/2008: '||RSP);









-- ************************************ votaci al municipi d'Olot 02/01/2010 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi d''Olot');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi d''Olot de 2 de gener de 2010';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Olot', 'cens Espanya', 'cens ES_Catalunya', 'Olot', 'Espanya', 2010, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Olot per votacio al municipi d''Olot de 02/01/2010: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 2, 3, 5, 6, 9 o 0.
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 2 OR  
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (estats vlids com a nou estat: 'pendent obertura', 'oberta', 'finalitzada')
-- --------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi d''Olot de 02/01/2010: '||RSP);









-- ************************************ votaci al municipi de Girona 03/01/2010 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Girona');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Girona de 3 de gener de 2010';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2010, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Girona per votacio al municipi de  de 03/01/2010: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 2, 3, 5, 6, 7, 9 o 0.
	-- tpicament s'esperaria una participaci del 70%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 2 OR  
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 6 OR 
		MOD(ciutada.id_ciutada, 10) = 7 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (nou estat: 'finalitzada')
-- -------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al municipi de Girona de 03/01/2010: '||RSP);










-- ************************************* votaci Parlament de Catalunya 01/11/2011 ************************************************************



 dbms_output.put_line(CHR(10)||CHR(13)||'votacio Parlament de Catalunya');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'Alta de censosAssociats');



 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011';




-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Barcelona', 'cens Espanya', 'cens ES_Catalunya', 'Barcelona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Barcelona per votacio Parlament de Catalunya 01/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Girona per votacio Parlament de Catalunya 01/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Lleida', 'cens Espanya', 'cens ES_Catalunya', 'Lleida', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Lleida per votacio Parlament de Catalunya 01/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Tarragona', 'cens Espanya', 'cens ES_Catalunya', 'Tarragona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Tarragona per votacio Parlament de Catalunya 01/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Olot', 'cens Espanya', 'cens ES_Catalunya', 'Olot', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Olot per votacio Parlament de Catalunya 01/11/2011: '||RSP);


 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);


 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori parell o acabat en 9.
	-- tpicament s'esperaria una participaci del 60%
	IF (	MOD(ciutada.id_ciutada, 2) = 0 OR
		MOD(ciutada.id_ciutada, 10) = 9 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;

	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (estats vlids com a nou estat: 'pendent obertura', 'oberta', 'finalitzada')
-- --------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al Parlament de Catalunya de 01/11/2011: '||RSP);







-- ********************************************** votaci Corts Generals 02/11/2011 ********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio Corts Generals');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');


 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions a Corts Generals de 2 de novembre de 2011';




-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Andalusia_Sevilla', 'cens Espanya', 'cens ES_Andalusia', 'Sevilla', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Andalusia_Sevilla per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Arago_Saragossa', 'cens Espanya', 'cens ES_Arago', 'Saragossa', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Arago_Saragossa per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Asturies_Oviedo', 'cens Espanya', 'cens ES_Asturies', 'Oviedo', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Asturies_Oviedo per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Balears_Palma', 'cens Espanya', 'cens ES_Balears', 'Palma de Mallorca', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Balears_Palma per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Canaries_Gran Canaria', 'cens Espanya', 'cens ES_Canaries', 'Les Palmes de Gran Canaria', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Canaries_Gran Canaria per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Cantabria_Santander', 'cens Espanya', 'cens ES_Cantabria', 'Santander', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Cantabria_Santander per votacio Corts Generals 08/01/2012: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Castella i Lleo_Valladolid', 'cens Espanya', 'cens ES_Castella i Lleo', 'Valladolid', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Castella i Lleo_Valladolid per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Castella la Manxa_Toledo', 'cens Espanya', 'cens ES_Castella la Manxa', 'Toledo', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Castella la Manxa_Toledo per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Barcelona', 'cens Espanya', 'cens ES_Catalunya', 'Barcelona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Barcelona per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Girona per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Lleida', 'cens Espanya', 'cens ES_Catalunya', 'Lleida', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Lleida per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Tarragona', 'cens Espanya', 'cens ES_Catalunya', 'Tarragona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Tarragona per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Olot', 'cens Espanya', 'cens ES_Catalunya', 'Olot', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Olot per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Extremadura_Merida', 'cens Espanya', 'cens ES_Extremadura', 'Merida', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Extremadura_Merida per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Galicia_Santiago de Compostela', 'cens Espanya', 'cens ES_Galicia', 'Santiago de Compostela', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Galicia_Santiago de Compostela per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat de Madrid_Madrid', 'cens Espanya', 'cens ES_Comunitat de Madrid', 'Madrid', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat de Madrid_Madrid per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat de Murcia_Murcia', 'cens Espanya', 'cens ES_Comunitat de Murcia', 'Murcia', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat de Murcia_Murcia per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Navarra_Pamplona', 'cens Espanya', 'cens ES_Navarra', 'Pamplona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Navarra_Pamplona per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Pais Basc_Vitoria', 'cens Espanya', 'cens ES_Pais Basc', 'Vitoria', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Pais Basc_Vitoria per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Rioja_Logronyo', 'cens Espanya', 'cens ES_Rioja', 'Logronyo', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Rioja_Logronyo per votacio Corts Generals 02/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat Valenciana_Valencia', 'cens Espanya', 'cens ES_Comunitat Valenciana', 'Valencia', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat Valenciana_Valencia per votacio Corts Generals 02/11/2011: '||RSP);



 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');



-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 2, 3, 4, 5, 7 o 9.
	-- tpicament s'esperaria una participaci del 60%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 2 OR  
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 4 OR 
		MOD(ciutada.id_ciutada, 10) = 5 OR 
		MOD(ciutada.id_ciutada, 10) = 7 OR 
		MOD(ciutada.id_ciutada, 10) = 9 ) THEN



		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;

	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (estats vlids com a nou estat: 'pendent obertura', 'oberta', 'finalitzada')
-- --------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions a Corts Generals de 02/11/2011: '||RSP);







-- ******************************************* votaci Parlament Europeu 03/11/2011 ********************************************************************



 dbms_output.put_line(CHR(10)||CHR(13)||'votacio Parlament Europeu');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');


 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al Parlament Europeu de 3 de novembre de 2011';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
-- Espanya
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Andalusia_Sevilla', 'cens Espanya', 'cens ES_Andalusia', 'Sevilla', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Andalusia_Sevilla per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Arago_Saragossa', 'cens Espanya', 'cens ES_Arago', 'Saragossa', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Arago_Saragossa per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Asturies_Oviedo', 'cens Espanya', 'cens ES_Asturies', 'Oviedo', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Asturies_Oviedo per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Balears_Palma', 'cens Espanya', 'cens ES_Balears', 'Palma de Mallorca', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Balears_Palma per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Canaries_Gran Canaria', 'cens Espanya', 'cens ES_Canaries', 'Les Palmes de Gran Canaria', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Canaries_Gran Canaria per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Cantabria_Santander', 'cens Espanya', 'cens ES_Cantabria', 'Santander', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Cantabria_Santander per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Castella i Lleo_Valladolid', 'cens Espanya', 'cens ES_Castella i Lleo', 'Valladolid', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Castella i Lleo_Valladolid per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Castella la Manxa_Toledo', 'cens Espanya', 'cens ES_Castella la Manxa', 'Toledo', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Castella la Manxa_Toledo per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Barcelona', 'cens Espanya', 'cens ES_Catalunya', 'Barcelona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Barcelona per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Girona per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Lleida', 'cens Espanya', 'cens ES_Catalunya', 'Lleida', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Lleida per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Tarragona', 'cens Espanya', 'cens ES_Catalunya', 'Tarragona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Tarragona per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Catalunya_Olot', 'cens Espanya', 'cens ES_Catalunya', 'Olot', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Catalunya_Olot per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Extremadura_Merida', 'cens Espanya', 'cens ES_Extremadura', 'Merida', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Extremadura_Merida per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Galicia_Santiago de Compostela', 'cens Espanya', 'cens ES_Galicia', 'Santiago de Compostela', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Galicia_Santiago de Compostela per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat de Madrid_Madrid', 'cens Espanya', 'cens ES_Comunitat de Madrid', 'Madrid', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat de Madrid_Madrid per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat de Murcia_Murcia', 'cens Espanya', 'cens ES_Comunitat de Murcia', 'Murcia', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat de Murcia_Murcia per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Navarra_Pamplona', 'cens Espanya', 'cens ES_Navarra', 'Pamplona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Navarra_Pamplona per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Pais Basc_Vitoria', 'cens Espanya', 'cens ES_Pais Basc', 'Vitoria', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Pais Basc_Vitoria per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Rioja_Logronyo', 'cens Espanya', 'cens ES_Rioja', 'Logronyo', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Rioja_Logronyo per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Comunitat Valenciana_Valencia', 'cens Espanya', 'cens ES_Comunitat Valenciana', 'Valencia', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Comunitat Valenciana_Valencia per votacio Parlament Europeu a 03/11/2011: '||RSP);
-- Alemanya
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Baden-Wurtenberg_Sttutgart', 'cens Alemanya', 'cens DE_Baden-Wurtenberg', 'Sttutgart', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Baden-Wurtenberg_Sttutgart per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Baviera_Munich', 'cens Alemanya', 'cens DE_Baviera', 'Munich', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Baviera_Munich per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Berlin_Berlin', 'cens Alemanya', 'cens DE_Berlin', 'Berlin', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Berlin_Berlin per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Brandemburgo_Potsdam', 'cens Alemanya', 'cens DE_Brandemburgo', 'Potsdam', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Brandemburgo_Potsdam per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Bremen_Bremen', 'cens Alemanya', 'cens DE_Bremen', 'Bremen', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Bremen_Bremen per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Hamburgo_Hamburgo', 'cens Alemanya', 'cens DE_Hamburgo', 'Hamburgo', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Hamburgo_Hamburgo per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Hesse_Wiesbaden', 'cens Alemanya', 'cens DE_Hesse', 'Wiesbaden', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Hesse_Wiesbaden per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Mecklemburgo_Schwerin', 'cens Alemanya', 'cens DE_Mecklemburg-pomerania occidental', 'Schwerin', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Mecklemburgo_Schwerin per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Baja Sajonia_Hannover', 'cens Alemanya', 'cens DE_Baja Sajonia', 'Hannover', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Baja Sajonia_Hannover per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Renania-Westfalia_Dusseldorf', 'cens Alemanya', 'cens DE_Renania del norte-Westfalia', 'Dusseldorf', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Renania-Westfalia_Dusseldorf per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Renania-Palatinado_Maguncia', 'cens Alemanya', 'cens DE_Renania-Palatinado', 'Maguncia', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Renania-Palatinado_Maguncia per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Sarre_Saarbrucken', 'cens Alemanya', 'cens DE_Sarre', 'Saarbrucken', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Sarre_Saarbrucken per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Sajonia_Dresde', 'cens Alemanya', 'cens DE_Sajonia', 'Dresde', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Sajonia_Dresde per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Sajonia-Anhalt_Magdeburgo', 'cens Alemanya', 'cens DE_Sajonia-Anhalt', 'Magdeburgo', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Sajonia-Anhalt_Magdeburgo per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Schleswig-Holstein_Kiel', 'cens Alemanya', 'cens DE_Schleswig-Holstein', 'Kiel', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Schleswig-Holstein_Kiel per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Turingia_Erfurt', 'cens Alemanya', 'cens DE_Turingia', 'Erfurt', 'Alemanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Turingia_Erfurt per votacio Parlament Europeu a 03/11/2011: '||RSP);
-- Italia
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Els Abrucos_L''Aquila', 'cens Italia', 'cens IT_Els Abrucos', 'L''Aquila', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Els Abrucos_L''Aquila per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Basilicata_Potenza', 'cens Italia', 'cens IT_Basilicata', 'Potenza', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Basilicata_Potenza per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Calabria_Catanzaro', 'cens Italia', 'cens IT_Calabria', 'Catanzaro', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Calabria_Catanzaro per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Campania_Napols', 'cens Italia', 'cens IT_Campania', 'Napols', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Campania_Napols per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Emilia-Romanya_Bolonya', 'cens Italia', 'cens IT_Emilia-Romanya', 'Bolonya', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Emilia-Romanya_Bolonya per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Friul--Venecia Julia_Trieste', 'cens Italia', 'cens IT_Friul--Venecia Julia', 'Trieste', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Friul--Venecia Julia_Trieste per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Laci_Roma', 'cens Italia', 'cens IT_Laci', 'Roma', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Laci_Roma per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Liguria_Genova', 'cens Italia', 'cens IT_Liguria', 'Genova', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Liguria_Genova per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Llombardia_Mila', 'cens Italia', 'cens IT_Llombardia', 'Mila', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Llombardia_Mila per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Les Marques_Ancona', 'cens Italia', 'cens IT_Les Marques', 'Ancona', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Les Marques_Ancona per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Molise_Campobasso', 'cens Italia', 'cens IT_Molise', 'Campobasso', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Molise_Campobasso per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Piemont_Tori', 'cens Italia', 'cens IT_Piemont', 'Tori', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat cens Piemont_Tori per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Apulia_Bari', 'cens Italia', 'cens IT_Apulia', 'Bari', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Apulia_Bari per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Sardenya_Caller', 'cens Italia', 'cens IT_Sardenya', 'Caller', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Sardenya_Caller per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Vall d''Aosta_Aosta', 'cens Italia', 'cens IT_Vall d''Aosta', 'Aosta', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Vall d''Aosta_Aosta per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Toscana_Florencia', 'cens Italia', 'cens IT_Toscana', 'Florencia', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Toscana_Florencia per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Umbria_Perusa', 'cens Italia', 'cens IT_Umbria', 'Perusa', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Umbria_Perusa per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Sicilia_Palerm', 'cens Italia', 'cens IT_Sicilia', 'Palerm', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Sicilia_Palerm per votacio Parlament Europeu a 03/11/2011: '||RSP);
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Veneto_Venecia', 'cens Italia', 'cens IT_Veneto', 'Venecia', 'Italia', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Veneto_Venecia per votacio Parlament Europeu a 03/11/2011: '||RSP);



 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura' i llavors a estat 'oberta' i ja estar a punt per rebre vots
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'oberta', RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');


-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
  -- recorrem un cursor no declarat que tindr tots els electors de la votaci id_vota
 FOR ciutada IN (SELECT id_ciutada FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id_vota) LOOP

	-- En aquest cas farem votar els electors identificats amb un nombre aleatori que acabi en 1, 3, 4, 9 o 0.
	-- tpicament s'esperaria una participaci del 50%
	IF ( 	MOD(ciutada.id_ciutada, 10) = 1 OR  
		MOD(ciutada.id_ciutada, 10) = 3 OR 
		MOD(ciutada.id_ciutada, 10) = 4 OR 
		MOD(ciutada.id_ciutada, 10) = 9 OR 
		MOD(ciutada.id_ciutada, 10) = 0 ) THEN

		-- busquem el codi del pas del ciutad (el necessitem per la funci que ens torna una opci de vot aleatria i vlida)
		SELECT nom_pais INTO pais FROM UOC_TFC.ciutadans WHERE num_aleatori = ciutada.id_ciutada;
		SELECT codi_pais INTO cod_pais FROM UOC_TFC.paisos WHERE nom_pais = pais;

		-- obtenim una opci de vot aleatria vlida dins la votaci i vlida per l'elector
		id_opc := UOC_TFC.pk_utils.f_opcio_aleatoria(id_vota, cod_pais);

		-- si la funci no retorna error (0) s'exerceix el vot
		IF ( id_opc <> 0 ) THEN

			UOC_TFC.pk_votacions.p_altaVotEmes(ciutada.id_ciutada, id_vota, id_opc, LOCALTIMESTAMP, RSP);
			dbms_output.put_line('Vot emes. ciutada: '||ciutada.id_ciutada||', id_votacio: ' ||id_vota||', id_opcio de vot: ' ||id_opc||' : '||RSP);

		END IF;
 	END IF;

 END LOOP;


-- actualitzaEstatVotacio (id_votacio, nou_estat) (estats vlids com a nou estat: 'pendent obertura', 'oberta', 'finalitzada')
-- --------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'finalitzada', RSP);
 dbms_output.put_line(CHR(10)||CHR(13)||'finalitzacio de la votacio Eleccions al Parlament Europeu de 03/11/2011: '||RSP);







-- ############################################# Votacions no finalitzades (en edici) #############################################################






-- ************************************ votaci al municipi de Sevilla 02/02/2012 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Sevilla (en estat edicio)');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');


 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Sevilla de 2 de febrer de 2012';


-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio, 
-- 					 									 ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Andalusia_Sevilla', 'cens Espanya', 'cens ES_Andalusia', 'Sevilla', 'Espanya', 2012, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Andalusia_Sevilla per votacio al municipi de Sevilla de 02/02/2012: '||RSP);


-- esborrat i reinsreci d'un cens associat
 dbms_output.put_line(CHR(10)||CHR(13)||'esborrat i reinsercio del censAssociat per votacio al municipi de Sevilla de 02/02/2012');

-- baixa del cens associat
 UOC_TFC.pk_votacions.p_baixaCensAssociat(id_vota, 'cens Andalusia_Sevilla', RSP);
 dbms_output.put_line('baixa censAssociat Andalusia_Sevilla per votacio al municipi de Sevilla de 02/02/2012: '||RSP);

-- nova alta del cens associat
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Andalusia_Sevilla', 'cens Espanya', 'cens ES_Andalusia', 'Sevilla', 'Espanya', 2012, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Andalusia_Sevilla per votacio al municipi de Sevilla de 02/02/2012: '||RSP);



-- ************************************ votaci al municipi de Munich 03/02/2012 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Munich (en estat edicio)');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');


 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Munich de 3 de febrer de 2012';


-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 					 									 ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Baviera_Munich', 'cens Alemanya', 'cens DE_Baviera', 'Munich', 'Alemanya', 2012, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Baviera_Munich per votacio al municipi de Munich de 03/02/2012: '||RSP);








-- ************************************ votaci al municipi de Roma 04/02/2012 **********************************************************************


 dbms_output.put_line(CHR(10)||CHR(13)||'votacio al municipi de Roma (en estat pendent obertura)');
 dbms_output.put_line('-------------------------------------------');

 dbms_output.put_line(CHR(10)||CHR(13)||'Alta de censosAssociats');


 -- escollim l'dentificador de la votaci
 SELECT id INTO id_vota FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Roma de 4 de febrer de 2012';



-- Alta de censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio,
-- 														  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 UOC_TFC.pk_votacions.p_altaCensAssociat(id_vota, 'cens Laci_Roma', 'cens Italia', 'cens IT_Laci', 'Roma', 'Italia', 2012, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat Laci_Roma per votacio al municipi de Roma de 04/02/2012: '||RSP);



 -- Una vegada afegits els censos, posem la votaci a estat 'pendent obertura'
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id_vota, 'pendent obertura', RSP);





-- ************************************************* FI votacions ****************************************************************


END;
/