SET SERVEROUTPUT ON;
SET LINESIZE 180;



DECLARE

 RSP 		VARCHAR2(240 CHAR);
 id1 		NUMBER := 0;
 id2 		NUMBER := 0;
 id3 		NUMBER := 0;
 id4 		NUMBER := 0;
 id_estat1	NUMBER := 0;
 id_estat2	NUMBER := 0;
 id_estat3	NUMBER := 0;
 id_estat4	NUMBER := 0;
 data_x 	VARCHAR2(12 CHAR);
 id_cens_ciutada_actiu	VARCHAR2(40 CHAR);
 id_cens_ciutada_baixa	VARCHAR2(40 CHAR);
 id_cens_votacio_activa	VARCHAR2(40 CHAR);

BEGIN



-- insercions a la taula anys (any)
-- --------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||'insercions a la taula anys');
dbms_output.put_line('-------------------------------------------------');

-- any NULL
 UOC_TFC.pk_votacions.p_altaAnys(NULL, RSP);
 dbms_output.put_line('insercio taula anys amb any NULL: '||RSP);

-- any negatiu
 UOC_TFC.pk_votacions.p_altaAnys(-1, RSP);
 dbms_output.put_line('insercio a la taula anys d''un any negatiu: '||RSP);

-- any que no t 4 dgits
 UOC_TFC.pk_votacions.p_altaAnys(011, RSP);
 dbms_output.put_line('insercio a la taula anys d''un que no te 4 digits: '||RSP);

-- any anterior a l'any actual
 UOC_TFC.pk_votacions.p_altaAnys(1999, RSP);
 dbms_output.put_line('insercio a la taula anys d''un any anterior a l''any 2000: '||RSP);

-- any existent
 UOC_TFC.pk_votacions.p_altaAnys(2011, RSP);
 dbms_output.put_line('insercio d''un any ja existent a taula anys: '||RSP);




-- insercions a la taula codisISO (codi_pais, nom_pais)
-- ----------------------------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula codisISO');
dbms_output.put_line('----------------------------------------------------');

-- codi_pais NULL
 UOC_TFC.pk_territoris.p_altaCodisISO('', 'Austria', RSP);
 dbms_output.put_line('insercio taula codisISO amb codi_pais NULL: '||RSP);

-- codiISO_pais no t 2 carcters
 UOC_TFC.pk_territoris.p_altaCodisISO('A', 'Alemanya', RSP);
 dbms_output.put_line('insercio taula codisISO amb codi_pais difrent a 2 caracters: '||RSP);

-- nom_pais NULL
 UOC_TFC.pk_territoris.p_altaCodisISO('ZZ', NULL, RSP);
 dbms_output.put_line('insercio taula codisISO amb nom_pais NULL: '||RSP);

-- codiISO_pais ja existent
 UOC_TFC.pk_territoris.p_altaCodisISO('AT', 'Austria', RSP);
 dbms_output.put_line('insercio d''un codi ja existent a la taula codisISO: '||RSP);


-- nom_pais ja existent
 UOC_TFC.pk_territoris.p_altaCodisISO('RR', 'Austria', RSP);
 dbms_output.put_line('insercio d''un nom de pais ja existent a la taula codisISO: '||RSP);





-- insercions a la taula paisos (nom_pais, codi_pais)
-- --------------------------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula paisos');
dbms_output.put_line('------------------------------------------------');

-- nom_pais NULL
 UOC_TFC.pk_territoris.p_altaPais(NULL, 'CY', RSP);
 dbms_output.put_line('insercio a la taula paisos amb nom_pais NULL: '||RSP);

-- codi_pais NULL
 UOC_TFC.pk_territoris.p_altaPais('Xipre', NULL, RSP);
 dbms_output.put_line('insercio a la taula paisos amb codi_pais NULL: '||RSP);

-- codi_pais no t 2 carcters
 UOC_TFC.pk_territoris.p_altaPais('Xipre', 'CCC', RSP);
 dbms_output.put_line('insercio a la taula paisos amb codi_pais diferent a 2 caracters: '||RSP);

-- codi_pais no referencia cap CODI ISO
 UOC_TFC.pk_territoris.p_altaPais('Pais', 'ZZ', RSP);
 dbms_output.put_line('insercio a la taula paisos on el codi no referencia cap codi ISO: '||RSP);

-- nom_pais ja existent
 UOC_TFC.pk_territoris.p_altaPais('Xipre', 'CY', RSP);
 dbms_output.put_line('insercio d''un nom de pais ja existent a la taula paisos: '||RSP);

-- codi_pais ja existent
 UOC_TFC.pk_territoris.p_altaPais('ZZ', 'CY', RSP);
 dbms_output.put_line('insercio d''un codi de pais ja existent a la taula paisos: '||RSP);






-- insercions a la taula Regions (id, id_pais, nom_regio)
-- ------------------------------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula regions');
dbms_output.put_line('---------------------------------------------------');

-- identificador NULL
 UOC_TFC.pk_territoris.p_altaRegio(NULL, 'Alemanya', 'Turingi', RSP);
 dbms_output.put_line('alta regio amb identificador NULL: '||RSP);

-- id_pais NULL
 UOC_TFC.pk_territoris.p_altaRegio(-1, NULL, 'Turingi', RSP);
 dbms_output.put_line('alta regio amb identificador de pais NULL: '||RSP);

-- nom_regio NULL
 UOC_TFC.pk_territoris.p_altaRegio(-1, 'Alemanya', NULL, RSP);
 dbms_output.put_line('alta regio amb nom de regio NULL: '||RSP);

-- identificador inesperat (el camp id s'alimenta per una seqncia)
 UOC_TFC.pk_territoris.p_altaRegio(1, 'Alemanya', 'Turingi', RSP);
 dbms_output.put_line('alta regio amb identificador inesperat (identificador es autoincrement): '||RSP);

-- id_pais no referencia cap pais
 UOC_TFC.pk_territoris.p_altaRegio(-1, 'ZZ', 'Turingia', RSP);
 dbms_output.put_line('alta regio amb id_pais que no referencia cap Pais: '||RSP);

-- id_pais i nom_regio ja existent (restriccio UNIQUE)
 UOC_TFC.pk_territoris.p_altaRegio(-1, 'Alemanya', 'Turingia', RSP);
 dbms_output.put_line('alta regio amb violacio de restriccio UNIQUE: '||RSP);




-- insercions a la taula localitats (id, id_regio, nom_localitat)
-- --------------------------------------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula localitats');
dbms_output.put_line('----------------------------------------------------');

 SELECT id INTO id1 FROM UOC_TFC.regions WHERE id_pais = 'Espanya' AND nom_regio = 'Catalunya';

-- identificador NULL
 UOC_TFC.pk_territoris.p_altaLocalitat(NULL, id1, 'Girona', RSP);
 dbms_output.put_line('alta localitat amb identificador NULL: '||RSP);

-- id_regio NULL
 UOC_TFC.pk_territoris.p_altaLocalitat(-1, NULL, 'Girona', RSP);
 dbms_output.put_line('alta localitat amb identificador de regio NULL: '||RSP);

-- nom_localitat NULL
 UOC_TFC.pk_territoris.p_altaLocalitat(-1, id1, NULL, RSP);
 dbms_output.put_line('alta localitat amb nom de localitat NULL: '||RSP);

-- identificador ja existent
 UOC_TFC.pk_territoris.p_altaLocalitat(1, id1, 'Girona', RSP);
 dbms_output.put_line('alta localitat amb identificador no esperat (camp auto increment): '||RSP);

-- id_regio no referencia cap regio
 UOC_TFC.pk_territoris.p_altaLocalitat(-1, 999, 'Girona', RSP);
 dbms_output.put_line('alta localitat amb id_regio que no referencia cap regio: '||RSP);

-- id_regio i nom_localitat ja existent (restriccio UNIQUE)
 UOC_TFC.pk_territoris.p_altaLocalitat(-1, id1, 'Girona', RSP);
 dbms_output.put_line('alta localitat amb violacio de restriccio UNIQUE: '||RSP);




-- insercions a la taula censGlobal (nom_cens)
-- -------------------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula censGlobal');
dbms_output.put_line('-------------------------------------------------------');

-- nom_cens NULL
 UOC_TFC.pk_territoris.p_altacensGlobal(NULL, RSP);
 dbms_output.put_line('alta cens global amb el nom del cens NULL: '||RSP);


-- nom_cens ja existent
 UOC_TFC.pk_territoris.p_altacensGlobal('cens global CE', RSP);
 dbms_output.put_line('alta cens global amb nom cens ja existent: '||RSP);


-- nom_cens massa llarg
 UOC_TFC.pk_territoris.p_altacensGlobal('cens global CE cens global CE cens global CE', RSP);
 dbms_output.put_line('alta cens global amb nom cens massa llarg: '||RSP);




-- insercions a la taula censosEstatals (nom_cens, id_cens_global, codi_pais)
-- --------------------------------------------------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula censosEstatals');
dbms_output.put_line('----------------------------------------------------------');

-- nom_cens NULL
 UOC_TFC.pk_territoris.p_altaCensEstatal(NULL, 'cens global CE', 'CY', RSP);
 dbms_output.put_line('alta cens estatal amb el nom del cens NULL: '||RSP);

-- id_cens_global NULL
 UOC_TFC.pk_territoris.p_altaCensEstatal('cens Xipre', NULL, 'CY', RSP);
 dbms_output.put_line('alta cens estatal amb identificador de cens global NULL: '||RSP);

-- codi_pais NULL
 UOC_TFC.pk_territoris.p_altaCensEstatal('cens Xipre', 'cens global CE', NULL, RSP);
 dbms_output.put_line('alta cens estatal amb codi de pais NULL: '||RSP);

-- id_cens_global no referencia al cens global
 UOC_TFC.pk_territoris.p_altaCensEstatal('cens X', 'ZZ', 'CY', RSP);
 dbms_output.put_line('alta cens estatal on el cens global no es referencia: '||RSP);

-- codi_pais no referencia el codi de cap pas
 UOC_TFC.pk_territoris.p_altaCensEstatal('cens Y', 'cens global CE', 'ZZ', RSP);
 dbms_output.put_line('alta cens estatal on el codi pais no referencia cap codi: '||RSP);




-- insercions a la taula censosRegionals (nom_cens, id_cens_estatal, id_regio, nom_regio)
-- --------------------------------------------------------------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula censosRegionals');
dbms_output.put_line('----------------------------------------------------------');

 SELECT id INTO id1 FROM UOC_TFC.regions WHERE id_pais = 'Espanya' AND nom_regio = 'Andalusia';

-- nom_cens NULL
 UOC_TFC.pk_territoris.p_altaCensRegional(NULL, 'cens Espanya', id1, 'Andalusia', RSP);
 dbms_output.put_line('alta cens regional amb el nom del cens NULL: '||RSP);

-- id_cens_estatal NULL
 UOC_TFC.pk_territoris.p_altaCensRegional('nou_cens', NULL, id1, 'Andalusia', RSP);
 dbms_output.put_line('alta cens regional amb identificador de cens estatal NULL: '||RSP);

-- id_regio NULL
 UOC_TFC.pk_territoris.p_altaCensRegional('nou_cens', 'cens Espanya', NULL, 'Andalusia', RSP);
 dbms_output.put_line('alta cens regional amb identificador de regio NULL: '||RSP);

-- nom_regio NULL
 UOC_TFC.pk_territoris.p_altaCensRegional('nou_cens', 'cens Espanya', id1, NULL, RSP);
 dbms_output.put_line('alta cens regional amb nom de regio NULL: '||RSP);

-- id_cens_estatal no referencia cap cens estatal existent
 UOC_TFC.pk_territoris.p_altaCensRegional('nou_cens', 'ZZ', id1, 'Andalusia', RSP);
 dbms_output.put_line('alta cens regional on no es referencia cap cens estatal: '||RSP);


-- id_regio no referencia el codi de cap regio existent
 UOC_TFC.pk_territoris.p_altaCensRegional('nou_cens', 'cens Espanya', 999, 'Andalusia', RSP);
 dbms_output.put_line('alta cens regional on id_regio no referencia cap regio: '||RSP);


-- id_regio i nom_regio sn mtuament incoherents
 UOC_TFC.pk_territoris.p_altaCensRegional('nou_cens', 'cens Espanya', id1, 'Catalunya', RSP);
 dbms_output.put_line('alta cens estatal on id_regio i nom_regio no son coherents: '||RSP);





-- insercions a la taula censosLocals (nom_cens, id_cens_regional, id_localitat, nom_localitat, ciutadans_censats)
-- ---------------------------------------------------------------------------------------------------------------
 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula censosLocals');
 dbms_output.put_line('-------------------------------------------------');

 SELECT id INTO id1 FROM UOC_TFC.regions WHERE id_pais = 'Espanya' AND nom_regio = 'Catalunya';
 SELECT id INTO id2 FROM UOC_TFC.localitats WHERE id_regio = id1 AND nom_localitat = 'Girona';

-- nom_cens NULL
 UOC_TFC.pk_territoris.p_altaCensLocal(NULL, 'cens ES_Catalunya', id2, 'Girona', 0, RSP);
 dbms_output.put_line('alta cens local amb el nom del cens NULL: '||RSP);

-- id_cens_regional NULL
 UOC_TFC.pk_territoris.p_altaCensLocal('nou cens', NULL, id2, 'Girona', 0, RSP);
 dbms_output.put_line('alta cens local amb id_cens_regional a NULL: '||RSP);

-- id_localitat NULL
 UOC_TFC.pk_territoris.p_altaCensLocal('nou cens', 'cens ES_Catalunya', NULL, 'Girona', 0, RSP);
 dbms_output.put_line('alta cens local amb id_localitat a NULL: '||RSP);

-- nom_localitat NULL
 UOC_TFC.pk_territoris.p_altaCensLocal('nou cens', 'cens ES_Catalunya', id2, NULL, 0, RSP);
 dbms_output.put_line('alta cens local amb el nom de la localitat NULL: '||RSP);

-- ciutadans_censats NULL
 UOC_TFC.pk_territoris.p_altaCensLocal('nou cens', 'cens ES_Catalunya', id2, 'Girona', NULL, RSP);
 dbms_output.put_line('alta cens local amb els siutadans censats NULL: '||RSP);

-- identificador de localitat negatiu 
 UOC_TFC.pk_territoris.p_altaCensLocal('nou cens', 'cens ES_Catalunya', -1, 'Girona', 0, RSP);
 dbms_output.put_line('alta cens local amb identificador de localitat negatiu: '||RSP);


-- ciutadans censats diferent de zero
 UOC_TFC.pk_territoris.p_altaCensLocal('nou cens', 'cens ES_Catalunya', id2, 'Girona', 1, RSP);
 dbms_output.put_line('alta cens local un nombre de ciutadans censats diferent de zero: '||RSP);


-- id_cens_regional no referencia cap cens regional existent
 UOC_TFC.pk_territoris.p_altaCensLocal('nou cens', 'ZZ', id2, 'Girona', 0, RSP);
 dbms_output.put_line('alta cens local on no es refencia cap dels censos regionals: '||RSP);

-- id_localitat no refencia cap localitat de les existents
 UOC_TFC.pk_territoris.p_altaCensLocal('nou cens', 'cens ES_Catalunya', 9999, 'Girona', 0, RSP);
 dbms_output.put_line('alta cens local on no es referencia cap de les localitats existents: '||RSP);

-- id_localitat i nom_localitat sn mtuament incoherents
 UOC_TFC.pk_territoris.p_altaCensLocal('nou cens', 'cens ES_Catalunya', id2, 'Barcelona', 0, RSP);
 dbms_output.put_line('alta cens local on id_localitat i nom_localitat no son coherents: '||RSP);




-- insercions a la taula estatsVotacio (id, nom_estat)
-- ----------------------------------------------------
 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula estatsVotacio');
 dbms_output.put_line('-----------------------------------------------------');

-- id NULL
 UOC_TFC.pk_votacions.p_altaEstatVotacio(NULL, 'edicio', RSP);
 dbms_output.put_line('alta estat votacio amb l''identificador NULL: '||RSP);

-- nom_estat NULL
 UOC_TFC.pk_votacions.p_altaEstatVotacio(-1, NULL, RSP);
 dbms_output.put_line('alta estat votacio amb el nom de l''estat NULL: '||RSP);

-- id no negatiu
 UOC_TFC.pk_votacions.p_altaEstatVotacio( 0, 'edicio', RSP);
 dbms_output.put_line('alta estat votacio amb id no negatiu: '||RSP);

-- nom_estat fora dels estats possibles ('edicio', 'pendent obertura', 'oberta', 'finalitzada')
 UOC_TFC.pk_votacions.p_altaEstatVotacio(-1, 'ZZ', RSP);
 dbms_output.put_line('alta estat votacio amb un nom d''estat que no esta entre els esperats: '||RSP);






-- insercions a la taula opcions (id, nom_opcio, descripcio, codi_pais, baixa_logica)
-- --------------------------------------------------------------------
 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula opcions');
 dbms_output.put_line('-------------------------------------------------');

-- id NULL
 UOC_TFC.pk_votacions.p_altaOpcio(NULL, 'BLANC', 'per dipositar un vot afirmatiu en una consulta', 'ZQ', 0, RSP);
 dbms_output.put_line('alta opcio amb id NULL: '||RSP);

-- nom_opcio a NULL
 UOC_TFC.pk_votacions.p_altaOpcio(-1, NULL, 'per dipositar un vot afirmatiu en una consulta', 'ZQ', 0, RSP);
 dbms_output.put_line('alta opcio amb nom opcio NULL: '||RSP);

-- nom_opcio a NULL
 UOC_TFC.pk_votacions.p_altaOpcio(-1, 'BLANC', 'per dipositar un vot afirmatiu en una consulta', NULL, 0, RSP);
 dbms_output.put_line('alta opcio amb codi_pais NULL: '||RSP);

-- nom_opcio de mes de 15 carcters
 UOC_TFC.pk_votacions.p_altaOpcio(-1, 'nom_opcio massa llarg', 'per dipositar un vot afirmatiu en una consulta', 'ZQ', 0, RSP);
 dbms_output.put_line('alta opcio amb nom opcio massa llarg: '||RSP);

-- codi_pais amb un nombre de carcters diferent a 2
 UOC_TFC.pk_votacions.p_altaOpcio(-1, 'BLANC', 'per dipositar un vot afirmatiu en una consulta', 'Z', 0, RSP);
 dbms_output.put_line('alta opcio amb codi_pais amb un nombre de caracters diferent a 2: '||RSP);


-- codi_pais no referencia cap codiISO
 UOC_TFC.pk_votacions.p_altaOpcio(-1, 'BLANC', 'per dipositar un vot afirmatiu en una consulta', 'ZZ', 0, RSP);
 dbms_output.put_line('alta opcio amb codi_pais que no referencia cap codi ISO: '||RSP);

-- baixa_logica = 1
 UOC_TFC.pk_votacions.p_altaOpcio(-1, 'BLANC', 'per dipositar un vot afirmatiu en una consulta', 'ZQ', 1, RSP);
 dbms_output.put_line('alta opcio amb baixa_logica activat: '||RSP);





-- insercions a la taula votacions (id, id_cens_global, id_estat, titol, data_inici, data_fi, any_votacio, adrea_web, president_mesa, num_electors)
-- que provocaran insercions a la taula estadistiquesVotacions
-- ---------------------------------------------------------------------------------------------------------------------------------
 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votacions');
 dbms_output.put_line('-------------------------------------------------');

-- id NULL
 UOC_TFC.pk_votacions.p_altaVotacio(NULL, 'cens global CE', 1, 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '01/11/2011', '11/12/2013', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb id NULL: '||RSP);

-- id_cens_global  NULL
 UOC_TFC.pk_votacions.p_altaVotacio(-1, NULL, 1, 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '01/11/2011', '11/12/2013', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb cens global NULL: '||RSP);

-- id_estat NULL
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', NULL, 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '01/11/2011', '11/12/2013', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb identificador estat NULL: '||RSP);

-- titol NULL
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, NULL, '01/11/2011', '11/12/2013', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb titol NULL: '||RSP);

-- data_inici NULL
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, 'Eleccions al Parlament de Catalunya de 1 de novembre', NULL, '01/11/2013', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb data d''inici NULL: '||RSP);

-- data_fi NULL
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '01/11/2011', NULL, '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb data de fi NULL: '||RSP);

-- any votacio NULL
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '01/11/2011', '11/12/2013', NULL, 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb any de la votacio NULL: '||RSP);

-- president mesa NULL
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '01/11/2011', '11/12/2013', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', NULL, 0, RSP);
 dbms_output.put_line('alta votacio amb data d''inici NULL: '||RSP);

-- num_electors NULL
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '01/11/2011', '11/12/2013', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', NULL, RSP);
 dbms_output.put_line('alta votacio amb numero d''electors NULL: '||RSP);

-- id de la votaci positiu o zero
 UOC_TFC.pk_votacions.p_altaVotacio(1, 'cens global CE', 1, 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '01/11/2011', '11/12/2013', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb un nombre natural com a identificador: '||RSP);

-- num_electors diferent a zero
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '01/11/2011', '11/12/2013', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 1, RSP);
 dbms_output.put_line('alta votacio amb un numero d''electors diferent a zero: '||RSP);

-- data_inici < data actual
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, 'Titol1', '01/12/2011', '31/12/2012', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb data d''inici < data actual: '||RSP);

-- data_inici > data_fi
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, 'Titol2', '12/12/2011', '11/12/2011', '2011', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb data de fi anterior a data inici: '||RSP);

-- any de la data_inici diferent a l'any de la votacio
 UOC_TFC.pk_votacions.p_altaVotacio(-1, 'cens global CE', 1, 'Titol3', '11/12/2011', '11/12/2011', '2012', 'http://www.gencat.cat/web/cat/bustia.htm', 'Pere Guinovart Serra', 0, RSP);
 dbms_output.put_line('alta votacio amb any_votacio equivocat: '||RSP);







-- insercions a la taula opcionsVotacio (id, id_votacio, id_opcio, num_vots)
-- -------------------------------------------------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula opcionsVotacio');
dbms_output.put_line('-------------------------------------------------');
 SELECT id INTO id1 FROM UOC_TFC.votacions WHERE titol = 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011';

-- id NULL
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(NULL, id1, 1, 0, RSP);
 dbms_output.put_line('alta opcio votacio amb id NULL: '||RSP);

-- id_votacio NULL
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(-1, NULL, 1, 0, RSP);
 dbms_output.put_line('alta opcio votacio amb id_votacio NULL: '||RSP);

-- id_opcio NULL
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(-1, id1, NULL, 0, RSP);
 dbms_output.put_line('alta opcio votacio amb id_opcio NULL: '||RSP);

-- num_vots NULL
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(-1, id1, 1, NULL, RSP);
 dbms_output.put_line('alta opcio votacio amb num_vots NULL: '||RSP);

-- id_votacio no positiu
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(-1, 0, 1, 0, RSP);
 dbms_output.put_line('alta opcio votacio amb id_votacio zero: '||RSP);

-- id_opcio no positiu
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(-1, id1, 0, 0, RSP);
 dbms_output.put_line('alta opcio votacio amb id_opcio zero: '||RSP);

-- num_vots negatiu
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(-1, id1, 1, -1, RSP);
 dbms_output.put_line('alta opcio votacio amb num_vots negatiu: '||RSP);


-- votaci inexistent
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(-1, 999, 1, 0, RSP);
 dbms_output.put_line('alta opcio votacio a una votacio inexistent: '||RSP);


-- opcio inexsitent
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(-1, id1, 99, 0, RSP);
 dbms_output.put_line('alta opcio votacio amb l''opcio inexistent: '||RSP);

-- votaci no editable 
 UOC_TFC.pk_votacions.p_altaOpcioVotacio(-1, id1, 1, 0, RSP);
 dbms_output.put_line('alta opcio votacio a una votacio que no es troba en estat ''edicio'': '||RSP);







-- insercions a la taula ciutadans (num_aleatori, id_cens_local, id_localitat, data_naixement, nom_pais, baixa_logica, num_participacions)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula ciutadans');
 dbms_output.put_line('-------------------------------------------------');

 id1 := UOC_TFC.pk_utils.f_num_aleatori;
 SELECT id_localitat INTO id2 FROM UOC_TFC.censosLocals WHERE nom_cens = 'cens Catalunya_Girona';

-- num_aleatori NULL
 UOC_TFC.pk_ciutadans.p_altaCiutada(NULL, 'cens Catalunya_Girona', id2, '01/01/1965', 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb num_aleatori NULL: '||RSP);

-- id_cens_local NULL
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, NULL, id2, '01/01/1965', 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb identificador de cens local NULL: '||RSP);

-- id_localitat NULL
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', NULL, '01/01/1965', 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb id_localitat NULL: '||RSP);

-- data_naixement NULL
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', id2, NULL, 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb data de naixement NULL: '||RSP);

-- nom_pais NULL
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', id2, '01/01/1965', NULL, 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb el nom del pais NULL: '||RSP);

-- baixa_logica NULL
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', id2, '01/01/1965', 'Espanya', NULL, 0, RSP);
 dbms_output.put_line('alta ciutada amb baixa_logica a NULL: '||RSP);

-- num_participacions a NULL
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', id2, '01/01/1965', 'Espanya', 0, NULL, RSP);
 dbms_output.put_line('alta ciutada amb num_participacions NULL: '||RSP);

-- id_localitat no positiu
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', 0, '01/01/1965', 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb identificador de localitat no positiu: '||RSP);

-- id_localitat no referencia cap localitat
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', 9999, '01/01/1965', 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb identificador de localitat que no referencia cap localitat: '||RSP);

-- id_cens_local no referencia cap cens local
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'zzz', id2, '01/01/1965', 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb identificador de cens local que no referencia cap cens local: '||RSP);

-- baixa_logica diferent a zero
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', id2, '01/01/1965', 'Espanya', 1, 0, RSP);
 dbms_output.put_line('alta ciutada amb baixa logica diferent de zero: '||RSP);

-- num_participacions diferent de zero
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', id2, '01/01/1965', 'Espanya', 0, 1, RSP);
 dbms_output.put_line('alta ciutada amb num_participacions diferent de zero: '||RSP);

-- id_cens_local i id_localitat incoherents
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Barcelona', id2, '01/01/1965', 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb incoherencies entre el cens local i la localitat: '||RSP);

-- id_cens_local i nom_pais incoherents (el pais del cens local no s nom_pais)
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', id2, '01/01/1965', 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada amb incoherencies entre el cens local i el nom del pais: '||RSP);

-- menor edat (< 18 en el moment de donar-lo d'alta al sistema)
 UOC_TFC.pk_ciutadans.p_altaCiutada(id1, 'cens Catalunya_Girona', id2, '10/02/1994', 'Espanya', 0, 0, RSP);
 dbms_output.put_line('alta ciutada menor edat respecte la data actual del sistema: '||RSP);



-- baixa lgia de ciutadans (num_aleatori)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'baixa logica ciutadans');
 dbms_output.put_line('-------------------------------------------------');


-- num_aleatori NULL
 UOC_TFC.pk_ciutadans.p_baixaCiutada(NULL, RSP);
 dbms_output.put_line('baixa logica de ciutada amb num_aleatori NULL: '||RSP);


-- num_aleatori negatiu o zero
 UOC_TFC.pk_ciutadans.p_baixaCiutada(0, RSP);
 dbms_output.put_line('baixa logica de ciutada amb num_aleatori zero: '||RSP);

-- num_aleatori de mes de nou digits
 UOC_TFC.pk_ciutadans.p_baixaCiutada(12345678910, RSP);
 dbms_output.put_line('baixa logica de ciutada amb num_aleatori massa llarg: '||RSP);

-- num_aleatori no referencia cap ciutada (esperem que no hagi sortit el nmero aleatori 1)
 UOC_TFC.pk_ciutadans.p_baixaCiutada(1, RSP);
 dbms_output.put_line('baixa logica de ciutada amb num_aleatori que no referencia cap ciutada de la BD: '||RSP);



-- insercions a la taula censosAssociats (id_votacio, id_cens_local, cens_estatal, cens_regional, nom_localitat, nom_pais, any_votacio
-- 					  ciutadans_censats, finalitzada, num_vots)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula censosAssociats');
 dbms_output.put_line('-------------------------------------------------');
 dbms_output.put_line('---NOTA: el procediment verifica el valor NULL de tots els parametres. No es comprovara en aquest testing.----');
 dbms_output.put_line('-----------------------------------------------------------------------------------------------------------------------');

-- id votaci de votaci inexistent
 UOC_TFC.pk_votacions.p_altaCensAssociat(999, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat amb id_votacio inexistent: '||RSP);

-- id_cens_local de cens local inexistent
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Catalunya_va_be', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat id_cens_local inexistent: '||RSP);

-- any votaci en format incorrecte
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 201, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat amb l''any amb format incorrecte (nombre de digits diferent a 4): '||RSP);

-- any votaci no corresponent a l'any de la votaci
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2020, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat amb param any_votacio no corresponent a l''any real de la votacio: '||RSP);

-- cens local no pertany al cens regional
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Andalusia_Sevilla', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat amb cens local que no correspon al cens regional: '||RSP);

-- cens regional no pertany al cens estatal
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Bremen_Bremen', 'cens Espanya', 'cens DE_Bremen', 'Girona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat amb cens regional que no correspon al cens estatal: '||RSP);

-- nom localitat no correspon al cens local
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Barcelona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat amb nom de localitat que no correspon a la localitat del cens local: '||RSP);

-- nom_pais no correspon al pais del cens estatal
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Belgica', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat amb nom pais que no correspon al pais del cens estatal: '||RSP);

-- id_votacio negatiu o zero
 UOC_TFC.pk_votacions.p_altaCensAssociat(0, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 0, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat amb id_votacio negatiu o zero: '||RSP);

-- ciutadans censats diferent a zero (tot i que el valor rebut no t massa importncia perqu s'actualitza en el procediment)
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 1, 0, 0, RSP);
 dbms_output.put_line('alta censAssociat amb un nombre de ciutadans censats diferent a zero: '||RSP);

-- finalitzada difrent a zero
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 0, 1, 0, RSP);
 dbms_output.put_line('alta censAssociat amb valor diferent a zero pel parametre finalitzada: '||RSP);

-- num_vots diferent de zero
 UOC_TFC.pk_votacions.p_altaCensAssociat(1, 'cens Catalunya_Girona', 'cens Espanya', 'cens ES_Catalunya', 'Girona', 'Espanya', 2011, 0, 0, 1, RSP);
 dbms_output.put_line('alta censAssociat amb num_vots diferent  a zero: '||RSP);








-- insercions a la taula votsEmesos (id_ciutada, id_votacio, id_opcio, data_hora)
-- ------------------------------------------------------------------------------
 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'insercions a la taula votsEmesos');
 dbms_output.put_line('-------------------------------------------------');

-- escollim l'dentificador d'una votaci
 SELECT id INTO id1 FROM UOC_TFC.votacions WHERE titol = 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011';
-- escollim un identificador d'opci de la votaci
 SELECT MIN(id_opcio) INTO id2 FROM UOC_TFC.opcionsVotacio WHERE id_votacio = id1;
-- escollim un elector de la votaci
  SELECT MIN(id_ciutada) INTO id3 FROM UOC_TFC.ciutadansVotacions WHERE id_votacio = id1;

-- id_ciutada NULL
 UOC_TFC.pk_votacions.p_altaVotEmes(NULL, id1, id2, LOCALTIMESTAMP, RSP);
 dbms_output.put_line('Vot emes amb id_ciutada NULL: : '||RSP);

-- id_votacio NULL
 UOC_TFC.pk_votacions.p_altaVotEmes(id3, NULL, id2, LOCALTIMESTAMP, RSP);
 dbms_output.put_line('Vot emes amb id_votacio NULL : '||RSP);


-- id_opcio NULL
 UOC_TFC.pk_votacions.p_altaVotEmes(id3, id1, '', LOCALTIMESTAMP, RSP);
 dbms_output.put_line('Vot emes amb id_opcio NULL : '||RSP);



-- data_hora NULL
 UOC_TFC.pk_votacions.p_altaVotEmes(id3, id1, id2, NULL, RSP);
 dbms_output.put_line('Vot emes amb data_hora NULL : '||RSP);



-- id_ciutada <= 0
 UOC_TFC.pk_votacions.p_altaVotEmes(-3, id1, id2, LOCALTIMESTAMP, RSP);
 dbms_output.put_line('Vot emes amb id_ciutada <= 0 : '||RSP);


-- id_votacio <= 0
 UOC_TFC.pk_votacions.p_altaVotEmes(id3, -1, id2, LOCALTIMESTAMP, RSP);
 dbms_output.put_line('Vot emes amb id_votacio <= 0: '||RSP);


-- id_opcio <= 0
 UOC_TFC.pk_votacions.p_altaVotEmes(id3, id1, -2, LOCALTIMESTAMP, RSP);
 dbms_output.put_line('Vot emes amb id_opcio <= 0 : '||RSP);

-- id_ciutada no s elector de la votaci (considerant que el generador aleatori no hagi generat 1)
 UOC_TFC.pk_votacions.p_altaVotEmes(1, id1, id2, LOCALTIMESTAMP, RSP);
 dbms_output.put_line('Vot emes amb id_ciutada no elector : '||RSP);

-- id_opcio no vlida per la votaci
 UOC_TFC.pk_votacions.p_altaVotEmes(id3, id1, 99, LOCALTIMESTAMP, RSP);
 dbms_output.put_line('Vot emes amb opcio no valida per la votacio : '||RSP);




-- actualitzaci de l'estat d'una votaci (id_votacio, nou_estat)
-- Nota: no es podran provar tots els casos que controla el procediment ja que no s'ha creat cap votaci en estat 'oberta'
-- -------------------------------------------------------------------------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'actualitzacio estats votacio (no es podran testejar tots els casos que controla el procediment.)');
 dbms_output.put_line('-------------------------------------------------------------------------------------------------------');


 SELECT id INTO id_estat1 FROM UOC_TFC.estatsVotacio WHERE nom_estat = 'edicio';
 SELECT id INTO id_estat2 FROM UOC_TFC.estatsVotacio WHERE nom_estat = 'pendent obertura';
 SELECT id INTO id_estat3 FROM UOC_TFC.estatsVotacio WHERE nom_estat = 'oberta';
 SELECT id INTO id_estat4 FROM UOC_TFC.estatsVotacio WHERE nom_estat = 'finalitzada';
 SELECT MIN(id) INTO id1 FROM UOC_TFC.votacions WHERE id_estat = id_estat1;	-- 'Eleccions al municipi de Sevilla de 2 de febrer de 2012'
 SELECT MIN(id) INTO id2 FROM UOC_TFC.votacions WHERE id_estat = id_estat2;	-- 'Eleccions al municipi de Roma de 4 de febrer de 2012'
 SELECT MIN(id) INTO id4 FROM UOC_TFC.votacions WHERE id_estat = id_estat4;	-- 'Eleccions al municipi de Sevilla de 2 de gener de 2000');

-- passar votaci en estat 'edicio' a estat diferent de 'pendent obertura'
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id1, 'oberta', RSP);
 dbms_output.put_line('actualitzacio de votacio en estat ''edicio'' a estat ''oberta'': '||RSP);


-- passar votaci en estat 'pendent obertura' a estat diferent de 'oberta'
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id2, 'edicio', RSP);
 dbms_output.put_line('actualitzacio de votacio en estat ''pendent obertura'' a estat ''edicio'' : '||RSP);


-- passar votaci en estat 'finalitzada' a qualsevol altre estat
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id4, 'edicio', RSP);
 dbms_output.put_line('actualitzacio de votacio en estat ''finalitzada'' a estat ''oberta'' : '||RSP);


-- posar votaci a estat 'oberta' abans que ho permeti la data d'inici
 UOC_TFC.pk_votacions.p_actualitzaEstatVotacio(id2, 'oberta', RSP);
 dbms_output.put_line('posar votacio a estat ''oberta'' abans d''hora: '||RSP);






-- esborrat  de censos (nom_cens)
--------------------------------------------------------------------------------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'intent d''esborrar censos amb votacions en estat ''oberta'' o ''finalitzada''.');
 dbms_output.put_line('-------------------------------------------------------------------------------------------------------');

-- cens global -- nom_cens NULL
 UOC_TFC.pk_territoris.p_baixaCensGlobal(NULL, RSP);
 dbms_output.put_line('esborrat del cens global amb identificador a NULL: '||RSP);

-- cens global -- nom_cens inexistent
 UOC_TFC.pk_territoris.p_baixaCensGlobal('cens global ZZZ', RSP);
 dbms_output.put_line('esborrat del cens global que no existeix: '||RSP);


-- cens global -- esborrat del cens quan cont votacions finalitzades
 UOC_TFC.pk_territoris.p_baixaCensGlobal('cens global CE', RSP);
 dbms_output.put_line('esborrat del cens global quan conte votacions obertes i/o finalitzades: '||RSP);



-- censos Estatals -- nom_cens NULL
 UOC_TFC.pk_territoris.p_baixaCensEstatal(NULL, RSP);
 dbms_output.put_line('esborrat del cens estatal amb identificador a NULL: '||RSP);

-- censos Estatals -- nom_cens inexistent
 UOC_TFC.pk_territoris.p_baixaCensEstatal('Cens estatal ZZZ', RSP);
 dbms_output.put_line('esborrat del cens estatal que no existeix: '||RSP);


-- censos Estatals -- esborrat del cens quan cont votacions finalitzades
 UOC_TFC.pk_territoris.p_baixaCensEstatal('cens Espanya', RSP);
 dbms_output.put_line('esborrat del cens estatal quan conte votacions obertes i/o finalitzades: '||RSP);



-- censos Regionals -- nom_cens NULL
 UOC_TFC.pk_territoris.p_baixaCensRegional(NULL, RSP);
 dbms_output.put_line('esborrat del cens regional amb identificador a NULL: '||RSP);

-- censos Regionals -- nom_cens inexistent
 UOC_TFC.pk_territoris.p_baixaCensRegional('Cens estatal ZZZ', RSP);
 dbms_output.put_line('esborrat del cens regional que no existeix: '||RSP);


-- censos Regionals -- esborrat del cens quan cont votacions finalitzades
 UOC_TFC.pk_territoris.p_baixaCensRegional('cens ES_Catalunya', RSP);
 dbms_output.put_line('esborrat del cens regional quan conte votacions obertes i/o finalitzades: '||RSP);


-- censos locals -- nom_cens NULL
 UOC_TFC.pk_territoris.p_baixaCensLocal(NULL, RSP);
 dbms_output.put_line('esborrat del cens local amb identificador a NULL: '||RSP);

-- censos locals -- nom_cens inexistent
 UOC_TFC.pk_territoris.p_baixaCensLocal('Cens estatal ZZZ', RSP);
 dbms_output.put_line('esborrat del cens local que no existeix: '||RSP);


-- censos locals -- esborrat del cens quan cont votacions finalitzades
 UOC_TFC.pk_territoris.p_baixaCensLocal('cens Catalunya_Girona', RSP);
 dbms_output.put_line('esborrat del cens local quan conte votacions obertes i/o finalitzades: '||RSP);




-- esborrat de votacions (titol_votacio)
-- -----------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'intent d''esborrar una votacio.');
 dbms_output.put_line('-------------------------------------------------------');


-- titol NULL
 UOC_TFC.pk_votacions.p_baixaVotacio(NULL, RSP);
 dbms_output.put_line('esborrat de votacio amb titol NULL: '||RSP);


-- titol massa llarg
 UOC_TFC.pk_votacions.p_baixaVotacio('Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011', RSP);
 dbms_output.put_line('esborrat de votacio amb titol massa llarg: '||RSP);


-- titol de votaci inexistent
 UOC_TFC.pk_votacions.p_baixaVotacio('ZZZ', RSP);
 dbms_output.put_line('esborrat de votacio amb titol que no referencia cap votacio: '||RSP);


-- votaci 'oberta' o 'finalitzada'
 UOC_TFC.pk_votacions.p_baixaVotacio('Eleccions al Parlament de Catalunya de 1 de novembre de 2011', RSP);
 dbms_output.put_line('esborrat de votacio amb estat ''oberta'' o ''finalitzada'': '||RSP);





-- esborrat d'opcions (nom_opcio, codi_pais) s clau alternativa
-- -----------------------------------------------------------------


 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'intent d''esborrar opcions.');
 dbms_output.put_line('-------------------------------------------------------');

-- nom_opcio NULL
 UOC_TFC.pk_votacions.p_baixaOpcio(NULL, 'ES', RSP);
 dbms_output.put_line('esborrat d''opcio amb nom_opcio NULL: '||RSP);


-- codi_pais NULL
 UOC_TFC.pk_votacions.p_baixaOpcio('PSOE', NULL, RSP);
 dbms_output.put_line('esborrat d''opcio amb codi_pais NULL: '||RSP);


-- nom_opcio massa llarg
 UOC_TFC.pk_votacions.p_baixaOpcio('LA OPCIO ES LLARGA', 'ES', RSP);
 dbms_output.put_line('esborrat d''opcio amb nom_opcio massa llarg: '||RSP);


-- codi_pais <> 2 carcters
 UOC_TFC.pk_votacions.p_baixaOpcio('PSOE', 'SIS', RSP);
 dbms_output.put_line('esborrat d''opcio amb codi_pais diferent de 2 caracters: '||RSP);

-- nom_opcio inexistent
 UOC_TFC.pk_votacions.p_baixaOpcio('ZZ', 'ES', RSP);
 dbms_output.put_line('esborrat d''opcio amb nom_opcio inexistent: '||RSP);

-- codi_pais inexistent
 UOC_TFC.pk_votacions.p_baixaOpcio('PSOE', 'ZZ', RSP);
 dbms_output.put_line('esborrat d''opcio amb codi_pais inexistent: '||RSP);

-- nom_opcio + codi_pais no referencien cap opcio
 UOC_TFC.pk_votacions.p_baixaOpcio('PSOE', 'IT', RSP);
 dbms_output.put_line('esborrat d''opcio que no referencia cap opcio real: '||RSP);

-- NOTA: actualment no hi ha cap opci de baixa ni cap votaci celebrant-se per testejar aquestes dues accions que el procediment controla.




-- esborrat de censosAssociats (id_votacio, id_cens_local)
-- ---------------------------------------------------------------------------------------------------------------------------------------
 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'intent d''esborrar cens associat');
 dbms_output.put_line('-------------------------------------------------');

SELECT id INTO id1 FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Sevilla de 2 de febrer de 2012';
-- id_votacio NULL
 UOC_TFC.pk_votacions.p_baixaCensAssociat(NULL, 'cens Andalusia_Sevilla', RSP);
 dbms_output.put_line('baixa censAssociat amb id_votacio NULL: '||RSP);

-- id_cens_local NULL
 UOC_TFC.pk_votacions.p_baixaCensAssociat(id1, NULL, RSP);
 dbms_output.put_line('baixa censAssociat amb id_cens_local NULL: '||RSP);


-- id_votaci de votaci inexistent
 UOC_TFC.pk_votacions.p_baixaCensAssociat(999, 'cens Andalusia_Sevilla', RSP);
 dbms_output.put_line('baixa censAssociat amb id_votacio inexistent: '||RSP);


-- id_cens_local de cens local inexistent
 UOC_TFC.pk_votacions.p_baixaCensAssociat(id1, 'zzz', RSP);
 dbms_output.put_line('baixa censAssociat id_cens_local inexistent: '||RSP);

-- id_votacio negatiu o zero
 UOC_TFC.pk_votacions.p_baixaCensAssociat(0, 'cens Andalusia_Sevilla', RSP);
 dbms_output.put_line('baixa censAssociat amb id_votacio negatiu o zero: '||RSP);

-- el cens no estava associat a la votacio
 UOC_TFC.pk_votacions.p_baixaCensAssociat(id1, 'cens Catalunya_Lleida', RSP);
 dbms_output.put_line('baixa censAssociat que no esta associat a la votacio: '||RSP);






-- esborrat a la taula opcionsVotacio (id_votacio, id_opcio)
-- -------------------------------------------------------------------------
dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'intent d''esborrar una opcio d''una Votacio');
dbms_output.put_line('-------------------------------------------------');

 SELECT id INTO id1 FROM UOC_TFC.votacions WHERE titol = 'Eleccions al municipi de Sevilla de 2 de febrer de 2012';
 SELECT id INTO id2 FROM UOC_TFC.opcions WHERE codi_pais = 'ZQ' AND nom_opcio = 'BLANC';
 SELECT id INTO id3 FROM UOC_TFC.opcions WHERE codi_pais = 'IT' AND nom_opcio = 'PD';
 SELECT id INTO id4 FROM UOC_TFC.votacions WHERE titol = 'Eleccions al Parlament Europeu de 3 de novembre de 2011';


-- id_votacio NULL
 UOC_TFC.pk_votacions.p_baixaOpcioVotacio(NULL, id2, RSP);
 dbms_output.put_line('baixa opcio votacio amb id_votacio NULL: '||RSP);

-- id_opcio NULL
 UOC_TFC.pk_votacions.p_baixaOpcioVotacio(id1, NULL, RSP);
 dbms_output.put_line('baixa opcio votacio amb id_opcio NULL: '||RSP);


-- id_votacio no positiu
 UOC_TFC.pk_votacions.p_baixaOpcioVotacio(0, id2, RSP);
 dbms_output.put_line('baixa opcio votacio amb id_votacio zero: '||RSP);

-- id_opcio no positiu
 UOC_TFC.pk_votacions.p_baixaOpcioVotacio(id1, 0, RSP);
 dbms_output.put_line('baixa opcio votacio amb id_opcio zero: '||RSP);


-- votaci inexistent
 UOC_TFC.pk_votacions.p_baixaOpcioVotacio(999, id2, RSP);
 dbms_output.put_line('baixa opcio votacio d''una votacio inexistent: '||RSP);


-- opcio inexsitent
 UOC_TFC.pk_votacions.p_baixaOpcioVotacio(id1, 999, RSP);
 dbms_output.put_line('baixa opcio votacio amb l''opcio inexistent a la taula opcions: '||RSP);


-- opcio no associada a la votaci
 UOC_TFC.pk_votacions.p_baixaOpcioVotacio(id1, id3, RSP);
 dbms_output.put_line('baixa opcio que no estava associada a la votacio: '||RSP);


-- votaci no editable 
 UOC_TFC.pk_votacions.p_baixaOpcioVotacio(id4, id2, RSP);
 dbms_output.put_line('baixa opcio votacio a una votacio que no es troba en estat ''edicio'': '||RSP);







-- modificacio de la descripci d'una opci (nom_opcio, codi_pais, nova_descripcio) {nom_opcio, codi_pais} s clau alternativa d'opci
-- -----------------------------------------------------------------------------------------------------------------------------------


 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'Modifiacio de la descripcio d''una opcio.');
 dbms_output.put_line('-------------------------------------------------------');

-- nom_opcio NULL
 UOC_TFC.pk_votacions.p_modificaOpcio_descripcio(NULL, 'ES', 'nova descripcio', RSP);
 dbms_output.put_line('modificacio de la descripcio d''una opcio amb nom_opcio NULL: '||RSP);


-- codi_pais NULL
 UOC_TFC.pk_votacions.p_modificaOpcio_descripcio('PSOE', NULL, 'nova descripcio', RSP);
 dbms_output.put_line('modificacio de la descripcio d''una opcio amb codi_pais NULL: '||RSP);

-- nom_opcio massa llarg
 UOC_TFC.pk_votacions.p_modificaOpcio_descripcio('LA OPCIO ES LLARGA', 'ES', 'nova descripcio', RSP);
 dbms_output.put_line('modificacio de la descripcio d''una opcio amb nom_opcio massa llarg: '||RSP);


-- nova descripcio massa llarga
 UOC_TFC.pk_votacions.p_modificaOpcio_descripcio('PSOE', 'ES', 'nova descripcio massa llarga. Una descripcio pot tenir un maxim de 100 caracters i aquesta els sobrepassa', RSP);
 dbms_output.put_line('modificacio de la descripcio d''una opcio amb nova descripcio massa llarga: '||RSP);


-- codi_pais <> 2 carcters
 UOC_TFC.pk_votacions.p_modificaOpcio_descripcio('PSOE', 'Z', 'nova descripcio', RSP);
 dbms_output.put_line('modificacio de la descripcio d''una opcio amb codi_pais diferent de 2 caracters: '||RSP);

-- nom_opcio inexistent
 UOC_TFC.pk_votacions.p_modificaOpcio_descripcio('ZZ', 'ES', 'nova descripcio', RSP);
 dbms_output.put_line('modificacio de la descripcio d''una opcio amb nom_opcio inexistent: '||RSP);

-- codi_pais inexistent
 UOC_TFC.pk_votacions.p_modificaOpcio_descripcio('PSOE', 'ZZ', 'nova descripcio', RSP);
 dbms_output.put_line('modificacio de la descripcio d''una opcio amb codi_pais inexistent: '||RSP);

-- nom_opcio+ codi_pais no referncien cap opcio
 UOC_TFC.pk_votacions.p_modificaOpcio_descripcio('PSOE', 'IT', 'nova descripcio', RSP);
 dbms_output.put_line('modificacio de la descripcio d''una opcio que no referencia cap opcio real: '||RSP);






-- Modificaci del ttol d'una votaci (titol_vell, titol_nou)
-- -----------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'Modificacio del titol d''una votacio');
 dbms_output.put_line('-------------------------------------------------------');


-- titol vell NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_titol(NULL, 'nou titol', RSP);
 dbms_output.put_line('Modificacio del titol d''una votacio amb titol vell NULL: '||RSP);

-- titol nou NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_titol('Eleccions al municipi de Roma de 4 de febrer de 2012', NULL, RSP);
 dbms_output.put_line('Modificacio del titol d''una votacio amb titol nou NULL: '||RSP);

-- titol vell massa llarg
 UOC_TFC.pk_votacions.p_modificaVotacio_titol('Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011', 'nou titol', RSP);
 dbms_output.put_line('Modificacio del titol d''una votacio amb titol vell massa llarg: '||RSP);


-- titol nou massa llarg
 UOC_TFC.pk_votacions.p_modificaVotacio_titol('Eleccions al municipi de Roma de 4 de febrer de 2012', 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011', RSP);
 dbms_output.put_line('Modificacio del titol d''una votacio amb titol nou massa llarg: '||RSP);

-- titol vell de votaci inexistent
 UOC_TFC.pk_votacions.p_modificaVotacio_titol('ZZZ', 'nou titol', RSP);
 dbms_output.put_line('Modificacio del titol d''una votacio amb titol vell inexistent: '||RSP);


-- titol nou de votaci ja existeix
 UOC_TFC.pk_votacions.p_modificaVotacio_titol('Eleccions al municipi de Roma de 4 de febrer de 2012', 'Eleccions al Parlament de Catalunya de 1 de novembre de 2011', RSP);
 dbms_output.put_line('Modificacio del titol d''una votacio amb titol nou que ja esxisteix a la BD: '||RSP);


-- votaci 'oberta' o 'finalitzada'
 UOC_TFC.pk_votacions.p_modificaVotacio_titol('Eleccions al Parlament de Catalunya de 1 de novembre de 2011', 'nou titol', RSP);
 dbms_output.put_line('Modificacio del titol d''una votacio que s''esta celebrant o que ja ha finalitzat: '||RSP);






-- Modificaci de la data d'inici d'una votaci (titol_vota, nova_data_inici)
-- ---------------------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'Modificacio de la data d''inici d''una votacio');
 dbms_output.put_line('-------------------------------------------------------');


-- titol NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_dataInici(NULL, '05/12/2012', RSP);
 dbms_output.put_line('Modificacio de la data d''inici d''una votacio amb titol NULL: '||RSP);


-- data_inici NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_dataInici('Eleccions al municipi de Roma de 4 de febrer de 2012', NULL, RSP);
 dbms_output.put_line('Modificacio de la data d''inici d''una votacio amb data d''inici NULL: '||RSP);

-- titol massa llarg
 UOC_TFC.pk_votacions.p_modificaVotacio_dataInici('Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '05/12/2012', RSP);
 dbms_output.put_line('Modificacio de la data d''inici d''una votacio amb titol massa llarg: '||RSP);



-- titol de votaci inexistent
 UOC_TFC.pk_votacions.p_modificaVotacio_dataInici('ZZZ', '05/12/2012', RSP);
 dbms_output.put_line('Modificacio de la data d''inici d''una votacio amb titol inexistent: '||RSP);


-- votaci 'oberta' o 'finalitzada'
 UOC_TFC.pk_votacions.p_modificaVotacio_dataInici('Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '05/12/2012', RSP);
 dbms_output.put_line('Modificacio de la data d''inici d''una votacio que s''esta celebrant o que ja ha finalitzat: '||RSP);


-- data_inici < data_actual
 UOC_TFC.pk_votacions.p_modificaVotacio_dataInici('Eleccions al municipi de Roma de 4 de febrer de 2012', '12/12/2011', RSP);
 dbms_output.put_line('Modificacio de la data d''inici d''una votacio amb data inici < data actual: '||RSP);


-- data_inici > data_fi
 UOC_TFC.pk_votacions.p_modificaVotacio_dataInici('Eleccions al municipi de Roma de 4 de febrer de 2012', '25/12/2012', RSP);
 dbms_output.put_line('Modificacio de la data d''inici d''una votacio amb data inici > data fi: '||RSP);




-- Modificaci de la data de fi d'una votaci (titol_vota, nova_data_fi)
-- ----------------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'Modificacio de la data de fi d''una votacio');
 dbms_output.put_line('-------------------------------------------------------');


-- titol NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_dataFi(NULL, '05/12/2012', RSP);
 dbms_output.put_line('Modificacio de la data de fi d''una votacio amb titol NULL: '||RSP);


-- data_inici NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_dataFi('Eleccions al municipi de Roma de 4 de febrer de 2012', NULL, RSP);
 dbms_output.put_line('Modificacio de la data de fi d''una votacio amb data d''inici NULL: '||RSP);

-- titol massa llarg
 UOC_TFC.pk_votacions.p_modificaVotacio_dataFi('Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '05/12/2012', RSP);
 dbms_output.put_line('Modificacio de la data de fi d''una votacio amb titol massa llarg: '||RSP);



-- titol de votaci inexistent
 UOC_TFC.pk_votacions.p_modificaVotacio_dataFi('ZZZ', '05/12/2012', RSP);
 dbms_output.put_line('Modificacio de la data de fi d''una votacio inexistent: '||RSP);


-- votaci 'oberta' o 'finalitzada'
 UOC_TFC.pk_votacions.p_modificaVotacio_dataFi('Eleccions al Parlament de Catalunya de 1 de novembre de 2011', '05/12/2012', RSP);
 dbms_output.put_line('Modificacio de la data de fi d''una votacio que s''esta celebrant o que ja ha finalitzat: '||RSP);


-- data_fi <= data_actual
 UOC_TFC.pk_votacions.p_modificaVotacio_dataFi('Eleccions al municipi de Roma de 4 de febrer de 2012', '12/12/2011', RSP);
 dbms_output.put_line('Modificacio de la data de fi d''una votacio amb data fi <= data actual: '||RSP);


-- data_fi < data_inici
 UOC_TFC.pk_votacions.p_modificaVotacio_dataFi('Eleccions al municipi de Roma de 4 de febrer de 2012', '03/02/2012', RSP);
 dbms_output.put_line('Modificacio de la data de fi d''una votacio amb data fi < data inici: '||RSP);





-- Modificaci de la web d'una votaci (titol_vota, nova_web)
-- -----------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'Modificacio de la web d''una votacio');
 dbms_output.put_line('-------------------------------------------------------');


-- titol NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_web(NULL, 'http://www.novaweb.com', RSP);
 dbms_output.put_line('Modificacio de la web d''una votacio amb titol NULL: '||RSP);


-- web NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_web('Eleccions al municipi de Roma de 4 de febrer de 2012', NULL, RSP);
 dbms_output.put_line('Modificacio de la web d''una votacio amb la URL de la nova web amb valor NULL: '||RSP);

-- titol massa llarg
 UOC_TFC.pk_votacions.p_modificaVotacio_web('Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011', 'http://www.novaweb.com', RSP);
 dbms_output.put_line('Modificacio de la web d''una votacio amb titol massa llarg: '||RSP);

-- web massa llarga
 UOC_TFC.pk_votacions.p_modificaVotacio_web('Eleccions al municipi de Roma de 4 de febrer de 2012', 'http://www.webmassallarga.comhttp://www.webmassallarga.comhttp://www.webmassallarga.comhttp://www.webmassallarga.comhttp://www.webmassallarga.comhttp://www.webmassallarga.comhttp://www.webmassallarga.com', RSP);
 dbms_output.put_line('Modificacio de la web d''una votacio amb la URL de nova web massa llarg: '||RSP);


-- titol de votaci inexistent
 UOC_TFC.pk_votacions.p_modificaVotacio_web('ZZZ', 'http://www.novaweb.com', RSP);
 dbms_output.put_line('Modificacio de la web d''una votacio inexistent: '||RSP);





-- Modificaci del president de mesa electoral d'una votaci (titol_vota, nou_president)
-- ------------------------------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'Modificacio del president de mesa electoral d''una votacio');
 dbms_output.put_line('-------------------------------------------------------');


-- titol NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_president(NULL, 'nom nou president', RSP);
 dbms_output.put_line('Modificacio del president de mesa d''una votacio amb parametre titol NULL: '||RSP);


-- nom nou president NULL
 UOC_TFC.pk_votacions.p_modificaVotacio_president('Eleccions al municipi de Roma de 4 de febrer de 2012', NULL, RSP);
 dbms_output.put_line('Modificacio del president de mesa d''una votacio amb el nom del nou president amb valor NULL: '||RSP);

-- titol massa llarg
 UOC_TFC.pk_votacions.p_modificaVotacio_president('Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011Eleccions al Parlament de Catalunya de 1 de novembre de 2011', 'nom nou president', RSP);
 dbms_output.put_line('Modificacio del president de mesa d''una votacio amb parametre titol massa llarg: '||RSP);


-- nom nou president massa llarg
 UOC_TFC.pk_votacions.p_modificaVotacio_president('Eleccions al municipi de Roma de 4 de febrer de 2012', 'nom nou president massa llarg nom nou president massa llarg nom nou president massa llarg nom nou president massa llarg', RSP);
 dbms_output.put_line('Modificacio del president de mesa d''una votacio amb el nom del nou president massa llarg: '||RSP);

-- titol de votaci inexistent
 UOC_TFC.pk_votacions.p_modificaVotacio_president('ZZZ', 'nom nou president', RSP);
 dbms_output.put_line('Modificacio del president de mesa d''una votacio inexistent: '||RSP);


-- votaci 'finalitzada'
 UOC_TFC.pk_votacions.p_modificaVotacio_president('Eleccions al Parlament de Catalunya de 1 de novembre de 2011', 'nom nou president', RSP);
 dbms_output.put_line('Modificacio del president de mesa d''una votacio que s''esta celebrant o que ja ha finalitzat: '||RSP);





-- Modificaci de la data de naixement d'un ciutada (id_ciutada, nova_data_naixement)
-- ---------------------------------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'Modificacio de la data de naixement d''un ciutada');
 dbms_output.put_line('-------------------------------------------------------');

 SELECT MAX(num_aleatori) INTO id1 FROM UOC_TFC.ciutadans WHERE baixa_logica = 0;
 SELECT MAX(num_aleatori) INTO id2 FROM UOC_TFC.ciutadans WHERE baixa_logica = 1;

-- id_ciutada NULL
 UOC_TFC.pk_ciutadans.p_modificaCiutada_dataNaix(NULL, '01/01/1950', RSP);
 dbms_output.put_line('Modificacio de la data de naixement d''un ciutada amb parametre id_ciutada NULL: '||RSP);

-- nova_data_naixement NULL
 UOC_TFC.pk_ciutadans.p_modificaCiutada_dataNaix(id1, NULL, RSP);
 dbms_output.put_line('Modificacio de la data de naixement d''un ciutada amb parametre nova_data_naix NULL: '||RSP);

-- id_ciutada negatiu o zero
 UOC_TFC.pk_ciutadans.p_modificaCiutada_dataNaix(0, '01/01/1950', RSP);
 dbms_output.put_line('Modificacio de la data de naixement d''un ciutada amb parametre id_ciutada negatiu o zero: '||RSP);

-- id_ciutada amb massa digits
 UOC_TFC.pk_ciutadans.p_modificaCiutada_dataNaix(12345678910, '01/01/1950', RSP);
 dbms_output.put_line('Modificacio de la data de naixement d''un ciutada amb parametre id_ciutada massa llarg: '||RSP);

-- id_ciutada no referencia cap ciutada (espero que no s'hagi generat l'aleatori 1)
 UOC_TFC.pk_ciutadans.p_modificaCiutada_dataNaix(1, '01/01/1950', RSP);
 dbms_output.put_line('Modificacio de la data de naixement d''un ciutada amb parametre id_ciutada que no referencia cap ciutada: '||RSP);

-- id_ciutada referencia un ciutada donat de baixa
 UOC_TFC.pk_ciutadans.p_modificaCiutada_dataNaix(id2, '01/01/1950', RSP);
 dbms_output.put_line('Modificacio de la data de naixement d''un ciutada amb parametre id_ciutada referencia un ciutada donat de baixa logica: '||RSP);

-- data naixement corresponent a un menor d'edat respecte la data actual
 UOC_TFC.pk_ciutadans.p_modificaCiutada_dataNaix(id1, '01/01/2000', RSP);
 dbms_output.put_line('Modificacio de la data de naixement d''un ciutada amb nova data corresponent a un menor d''edat: '||RSP);





-- Modificaci del cens local d'un ciutada (id_ciutada, nou_cens_local)
-- ---------------------------------------------------------------------------------------

 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'Modificacio del cens local d''un ciutada');
 dbms_output.put_line('-------------------------------------------------------');

 -- ciutad actiu en el qual el cens actual no est associat a cap votaci no finalitzada
 SELECT MAX(num_aleatori) INTO id1 FROM UOC_TFC.ciutadans WHERE baixa_logica = 0 AND id_cens_local NOT IN('cens Andalusia_Sevilla', 'cens Baviera_Munich', 'cens Laci_Roma');

 -- ciutad de baixa en el qual el cens actual no est associat a cap votaci no finalitzada
 SELECT MAX(num_aleatori) INTO id2 FROM UOC_TFC.ciutadans WHERE baixa_logica = 1;

 -- ciutad actiu en el qual el cens actual est associat a una votaci no finalitzada
 SELECT MAX(num_aleatori) INTO id3 FROM UOC_TFC.ciutadans WHERE baixa_logica = 0 AND id_cens_local IN('cens Andalusia_Sevilla', 'cens Baviera_Munich', 'cens Laci_Roma');

 SELECT id_cens_local INTO id_cens_ciutada_actiu FROM UOC_TFC.ciutadans WHERE num_aleatori = id1;
 SELECT id_cens_local INTO id_cens_ciutada_baixa FROM UOC_TFC.ciutadans WHERE num_aleatori = id2;
 SELECT id_cens_local INTO id_cens_votacio_activa FROM UOC_TFC.ciutadans WHERE num_aleatori = id3;


-- id_ciutada NULL
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(NULL, id_cens_ciutada_actiu, RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada amb parametre id_ciutada NULL: '||RSP);

-- nou_cens_local NULL
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(id1, NULL, RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada amb parametre nou_cens_local NULL: '||RSP);

-- id_ciutada negatiu o zero
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(-1, id_cens_ciutada_actiu, RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada amb parametre id_ciutada negatiu: '||RSP);

-- id_ciutada de ms de 10 dgits
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(12345678910, id_cens_ciutada_actiu, RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada amb parametre id_ciutada de mes de 10 digits: '||RSP);

-- nou_cens_local de ms de 40 carcters
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(id1, 'el nou cens no pot tenir mes de 40 caracters', RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada amb parametre nou_cens_local de mes de 40 caracters: '||RSP);

-- id_ciutada inexistent (esperem que el generador aleatori no hagi generat l'1)
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(1, id_cens_ciutada_actiu, RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada inexistent: '||RSP);

-- nou_cens_local inexistent
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(id1, 'ZZ', RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada amb nou_cens_local inexistent a la BD: '||RSP);

-- ciutada donat de baixa
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(id2, id_cens_ciutada_baixa, RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada donat de baixa: '||RSP);


-- antic cens local del ciutad associat a una votaci no finalitzada
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(id3, id_cens_ciutada_actiu, RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada amb antic cens associat a una votacio no finalitzada: '||RSP);


-- nou cens local del ciutad associat a una votaci no finalitzada
 UOC_TFC.pk_ciutadans.p_modificaCiutada_censLocal(id1, id_cens_votacio_activa, RSP);
 dbms_output.put_line('Modificacio del cens local d''un ciutada amb nou cens associat a una votacio no finalitzada: '||RSP);



 dbms_output.put_line(CHR(10)||CHR(13)||CHR(10)||CHR(13)||'FI DEL TESTING !!');
 dbms_output.put_line('-------------------------------------------------------');




END;
/