

-- connectat com a SYSDBA

-- DROP USER UOC_TFC CASCADE;
-- DROP USER invitat CASCADE;


-- usuari creador de les taules, disparadors, seqncies, paquets i procediments
CREATE USER UOC_TFC
  IDENTIFIED BY clau_UOC_TFC
  DEFAULT TABLESPACE users
  QUOTA UNLIMITED ON users
  TEMPORARY TABLESPACE temp;

GRANT CREATE SESSION, CREATE TABLE, CREATE TRIGGER, CREATE SEQUENCE, CREATE PROCEDURE TO UOC_TFC;
GRANT CREATE SESSION, EXECUTE ANY PROCEDURE TO PUBLIC;



-- Es crea un usuari 'invitat' que representa a un usuari qualsevol i que tindr permisos per:
-- * executar els procediments creats per l'usuari UOC_TFC
-- * fer consultes sobre les taules de l'usuari UOC_TFC

-- Ni l'usuari invitat, ni un usuari qualsevol, no tindran permisos per fer cap tipus d'actualitzaci sobre 
-- les taules de UOC_TFC mitjanant sentncies SQL directes sobre la BD. 
-- D'aquesta manera evitarem que els diferents usuaris puguin modificar i/o esborrar dades de la BD de manera 
-- incontrolada. Tota la responsabilitat sobre les actualitzacions incontrolades de les dades recau en l'usuari 
-- UOC_TFC (veure apartat 3 del document jmasanas_manual_usuari.doc).


CREATE USER invitat
  IDENTIFIED BY clau_invitat
  DEFAULT TABLESPACE users
  QUOTA UNLIMITED ON users
  TEMPORARY TABLESPACE temp;




